package roboforge;

import java.util.*;

public interface BAiOperator
{


  // get the value
  public String getCurrentValue();

  // get the Type
  public String getType();

  // return the item from the currentList that matches this operator
  public BAiOperator getCurrent(Vector channelVector, Vector statesVector);

  public String getDesc();

  // get the Options for this operator
  public Vector getOptionsVector(BBot currentBot);

  // true if the users must select from the options, false if the user may type in values
  public boolean getMustChooseFromList();

  public boolean isZonesTest();


} 