package roboforge;

import java.awt.*;
//import java.io.*;
//import javax.swing.*;
//import java.awt.event.*;
//import javax.swing.border.*;
//import java.awt.image.MemoryImageSource;

class BColorDisplay extends Canvas
{
  /**
	 * 
	 */
	private static final long serialVersionUID = -1L;
private Color currentColor;

  public void setColor(Color newColor)
  {
    currentColor = newColor;
    repaint();
  }

  public void update(Graphics g)
  {   // Don't clear to bg color on update
    paint(g);
  }

  public void paint(Graphics g)
  {
    g.setColor(currentColor);
    g.fillRect(0, 0, getSize().width, getSize().height);
  }
}
