package roboforge;

import java.io.*;
//import javax.vecmath.*;

public class BComponentTransform implements Serializable
{
  /*

  * Description:
    Holds a BJointPosition

  * Example:
  * Modification History ( Name, Date, Notes ):
    HSC, 25-March-1999
    HSC, 12-May-1999
    Changed joint to be of Type object and added two swap methods
    to allow for the use of Shadow bots

  */

  static final long serialVersionUID = -1L;

  private BJoint joint;
  private BJointPosition jointPosition;

  public BComponentTransform(BJoint jointIn)
  {
    joint = jointIn;
    jointPosition = (BJointPosition)jointIn.getJointPosition().clone();
  }

  public BJoint getJoint ()
  {
    return (BJoint)joint;
  }

  public void setJoint(BJoint jointIn)
  {
    joint = jointIn;
  }

  public BJointPosition getJointPosition ()
  {
    return jointPosition;
  }

  public void setJointPosition ( BJointPosition jointPosIn)
  {
    jointPosition = (BJointPosition) jointPosIn.clone();
  }



}///:~