package roboforge;



public interface BMouseListenerCanvas {


  public void exitWireFrame();
  // Exit the Wireframe state

  public void setWireFrame(BComponent theComponent);
  // Turn the component and all its children into wireframes

  public void setWireFrame();
  // Turn the entire scene into wireframe

  public BHighlightShape getLastSelected();
  // get the last selected shape for a canvas

  public int getMode() ;
  //get the Mode

  public void modeMethod(BHighlightShape shape);
  // Perform a pick method associated with the canvases Mode

  public void repaint();
  // repaint the canvas

  public void takeSnapshot();
  // snapshot

  public void waitForFrame();
  // wait for the next frame


  public javax.media.j3d.Locale getLocale3d();
  // get the canvas Locale

  public void removeComponent  (BComponent theComponent);
  //removes the component  passed in from the canvas,
  // also removes all children and cleans up memmory




}
