package roboforge.ai.decisions;

import javax.swing.Icon;
import roboforge.BGlobal;
import roboforge.ui.components.BBorderedIcon;


public class BBlockNode extends BGroupNode
{
  protected static BBorderedIcon icon =
    createTreeIcon("ai/block_18.gif", BGlobal.colors.getAIGroupColor());


  public BBlockNode()
    { super(); }

  public BBlockNode(BBlockNode node)
    { super(node);  }

  public Object clone()
    { return new BBlockNode(this); }

  public Icon getSelectedIcon()
    { return getIcon(); }

  public Icon getIcon()
  {
    if (this.getVisited())
      icon.setBorderColor(BGlobal.colors.getLightestShade() );
    else
      icon.setBorderColor( BGlobal.colors.getAIGroupColor() );

    return icon;

  }

}