package roboforge.ai.expressions;

import roboforge.ai.values.*;


public abstract class BLogicalBinaryOp extends BBooleanBinaryOp
{

  // Serialization ID.
  // -----------------------------------------------------------
  static final long serialVersionUID = -1L;


  public BLogicalBinaryOp()
    { super(); }

  public BLogicalBinaryOp(BLogicalBinaryOp o)
    { super(o); }

  public BLogicalBinaryOp(BExpression l, BExpression r)
    { super(l, r); }


  protected int combineType(int l, int r)
  {
    if (l != r)
      return BType.UNDEFINED;

    else if (l == BType.BOOLEAN)
      return BType.BOOLEAN;

    else
      return BType.UNDEFINED;
  }

}