package roboforge.ai.expressions;

import roboforge.ai.values.*;


public abstract class BNumericBinaryOp extends BBinaryOp
{
  // Serialization ID.
  // -----------------------------------------------------------
  static final long serialVersionUID = -1L;

  protected transient BNumber value;

  public BNumericBinaryOp()
    { super(); }

  public BNumericBinaryOp(BNumericBinaryOp o)
    { super(o); }

  public BNumericBinaryOp(BExpression l, BExpression r)
    { super(l, r); }


  protected int combineType(int l, int r)
  {
    if ((l == r) && (l == BType.NUMBER))
      return BType.NUMBER;
    else
      return BType.UNDEFINED;
  }


  public void init()
    { value = new BNumber(); super.init(); }

}
