package roboforge.ai.worldstate;

import roboforge.*;
import roboforge.ai.values.*;

public class BZoneWorldItem extends BWorldItem
{

  static final long serialVersionUID = -1L;
  BZone theZone;

  public BZoneWorldItem(String key, String name ,BValue defaultValue, String units,String description, BZone theZone)
  {
   this( key,  name,  defaultValue,  defaultValue,  defaultValue,  units, description, theZone) ;
  }

  public BZoneWorldItem(String key, String name ,BValue defaultValue, BValue lower, BValue upper, String units, String description, BZone theZone)
  {
   super( key,  name,  defaultValue,  lower,  upper,description,   units) ;
   this.theZone = theZone;
  }

  public BZone getZone()
  { return theZone;}


}