package roboforge.animation.alpha;

import javax.vecmath.*;


public class BAlphaTuple4f extends Tuple4f implements BAlphaValue
{

  public BAlphaTuple4f()
    { super(); }

  public BAlphaTuple4f(float x, float y, float z, float w)
    { super(x, y, z, w); }

  public BAlphaTuple4f(Tuple4f t)
    { super(t); }


  public void set(BAlphaValue v)
    { super.set((Tuple4f) v); }

  public void interpolate(BAlphaValue v, float alpha)
    { super.interpolate((Tuple4f) v, alpha); }

  public BAlphaValue copy()
    { return new BAlphaTuple4f(this); }

}