package roboforge.arenaSystems;

import java.io.*;

public interface BArenaEvent extends Serializable
{
  // remmember to state the serlizeID for all seriliazed objects
  static final long serialVersionUID = -1L;
  
  public int getStateModifier();  // the amount to modify the internal crowdState By

  public String getArenaEventType(); // must be one of the following types;

  public static String COLLISION = "Collision";
  public static String DESTRUCTION = "Component Explosion";
  public static String END = "End of Battle";    // The end of the battle NOT including the victory moves
  public static String START = "Start of Battle";
  public static String DEADLOCK = "Bots in deadlock";
  public static String CLEAR_EVENTS = "Clear All Events";

  public static String BOTA_STARTMOVE = "Bot A's start moves";
  public static String BOTB_STARTMOVE = "Bot B's start moves";
  public static String STARTMOVES_FIN = "Start moves finished";
  public static String VICTORY_MOVES_START = "Victory Move";

}