package roboforge.net;

import roboforge.net.services.*;


public interface BPresentationLayer
{
  
  // Message send method...
  // -------------------------------------------------------------

  public void send(BTransmission t)
    throws BNetException;
      // Sends a message to target.


  // Message receive method...
  // -------------------------------------------------------------

  public void receive(BTransmission t)
    throws BNetException;
      // Receives a message from target.


  // Message request method...
  // -------------------------------------------------------------

  public void request(BTransmission t)
    throws BNetException;
    // Handles a request (that is, a send/receive pair.)

}
