package roboforge.net.services;

import roboforge.net.*;
import roboforge.net.sockets.*;

import java.io.IOException;



public abstract class BAbstractDataService implements BDataService
{
  
  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Abstract methods...
  // -----------------------------------------------------------

  public abstract BSocket getSocket(BSocket s) throws IOException;
  
  
  // Default encoding method...
  // -----------------------------------------------------------
  
  public void configure(BPresentationHeader header)
    { header.addService(this); }
  

  // Default inform method...
  // -----------------------------------------------------------
  
  public void inform(BServiceInfo info)
    { /* DO NOTHING */ }
  
  /*
  public void read(BTarget target)
    { } // DO NOTHING
    
  public void write(BTarget target)
    { } // DO NOTHING
  */
  
}
