package roboforge.ui.components;

import roboforge.BDebug;
import roboforge.BNameable;

import java.awt.Component;
import java.awt.event.*;

import javax.swing.ComboBoxEditor;
import javax.swing.border.EmptyBorder;

public class BNamedEditor
  extends    BNamedField
  implements ComboBoxEditor
{
  
  // protected BNameable item;
  
  protected BMutableListModel model;

  
  public BNamedEditor()
    { this(null); }

  public BNamedEditor(BMutableListModel model)
  {
    super();
    this.model = model;

    UpdateListener listener = new UpdateListener();
    addActionListener(listener);

    setBorder(new EmptyBorder(0, 4, 0, 0));
  }

  // Combo Editor Methods...
  // -------------------------------------------------------------

  public void setItem(Object o)
  {
    setNameable((BNameable) o);

    /*
    item = (BNameable) o;

    if (item != null)
      setText(item.getName());
    else
      setText("");
    */
  }

  public Object getItem()
    { return getNameable(); }

  public Component getEditorComponent()
    { return this; }

  
  protected class UpdateListener
    implements ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      if (named != null)
      {
        // item.setName(e.getActionCommand());

        if (model != null)
          model.notifyChange(named);
      }
    }
  }

}
