package roboforge.ui.components.text;

public abstract class BAbstractGuard implements BTextGuard
{
  
  // Interface methods...
  // -------------------------------------------------------------
  
  public boolean isValidInsertion(String cur, String ins, int offset)
  {
    char[] c = ins.toCharArray();

    for (int i=0; i<c.length; i++)
      if (!isValidChar(c[i], offset++))
        return false;
    
    return true;
  }
  
  public boolean isValidDeletion(String cur, int offset, int length)
    { return true; }

  
  // Abstract methods...
  // -------------------------------------------------------------

  protected abstract boolean isValidChar(char c, int i);
  
}
