package roboforge.ui.modes;

import roboforge.ui.*;

import java.awt.event.MouseEvent;
import java.util.Vector;
import javax.media.j3d.*;



public abstract class BModeCanvas extends BModeMouse
{

  protected B3DCanvas canvas = null;

  public BModeCanvas(B3DCanvas canvas)
    { this.canvas = canvas; }

  public void onActivate()
  {
    super.onActivate();
    // if (!isSubMode)
    //   canvas.setMode(this);

    canvas.setCursor(cursor);
  }

  public void onDeactivate()
  {
    // if (!isSubMode)
    //  canvas.setMode(null);

    canvas.setCursor();
    super.onDeactivate();
  }

  public void onClose()
  {
    canvas = null;
    super.onClose();
  }

}
