package roboforge.util.processors;

public interface BObjectProcessor
{
  // Starts the processor.
  public void start();

  // Stops the processor.
  public void stop();

  // Requests that Object o be processed.
  // - Can be called from any thread.
  public void request(Object o);

  // Processes Object o.
  // - Executes from the processor thread.
  public void processObject(Object o);

  public boolean isProcessing();
} 