package roboforge;


//import javax.vecmath.*;
import java.util.*;
//import javax.media.j3d.*;



public class BCpu extends BComponent
/*

* Description:
  A child of BComponent which can be transformed.

* Example:
* Modification History ( Name, Date, Notes ):
  HSC, 25-March-1999

*/

{
  // STATIC STUFF
  static final long serialVersionUID = -1L;

  // INSTANCE STUFF

  public int cpuCyclesPerSecond;  // Number of Cycles (Decision Squares) processed per second
//  public int cpuCapacity;         // Total number of Decision Squares contained in memory (max)
  public int cpuClass;            // Classification of CPU (1=Basic,2=Normal,3=Advanced)

   private int searchType = 0;

  public BCpu (String nameIn, String filename)
  {
      super(nameIn, filename);
  }

  public static String COMPONENT_TYPE = "Controller";

  public String getComponentType()
  { return COMPONENT_TYPE; }





  public void upgrade()
  {

    BCpu upgradeTwin =   (BCpu)BComponent.loadFromFile( BGlobal.COMPONENTPATH+getComponentFilePath() , false);

    super.upgrade(upgradeTwin);

    cpuCyclesPerSecond = upgradeTwin.cpuCyclesPerSecond;
    cpuClass = upgradeTwin.cpuClass;            // Classification of CPU (1=Basic,2=Normal,3=Advanced)
    searchType = upgradeTwin.searchType;



  }





  public int getCyclesPerSecond()
    { return cpuCyclesPerSecond; }

  public Vector getAttributeStrings()
 // returns a Vector of tuples  (heading, value )
 // 2-d Vector
 {

  Vector theList = super.getAttributeStrings();


  Vector tempV;

  tempV = new Vector(2);
  tempV.add("CPU speed");
  tempV.add(cpuCyclesPerSecond + " decisions/s");
  tempV.trimToSize();
  theList.add(tempV);

  return theList;

 }




}


