package roboforge;

//import java.awt.*;
import javax.swing.*;
//import java.util.*;
//import java.awt.event.*;
//import java.io.*;
//import javax.swing.tree.*;
//import java.beans.*;
//import javax.swing.event.*;
//import javax.swing.border.*;
//import java.net.*;
//import javax.swing.table.*;
//import javax.swing.plaf.*;
//import javax.swing.plaf.basic.*;
//import roboforge.net.*;


public class BForumPanel extends JPanel
{

	/**
	 * 
	 */
	private static final long serialVersionUID = -1L;
  /*
  JPanel parentPanel;
  int pWidth;
  int pHeight;
  Border panelBorder;
  String botFileName;




  BButton jBSubmit = new BButton();
  BButton jBUpdate = new BButton();
  BButton jBRemove = new BButton();

  JTextArea jTInfo = new JTextArea();
  JLabel jLAccBal = new JLabel();
  JLabel jLtournHeader = new JLabel();
  JScrollPane jSBotNames = new JScrollPane();
  JList jLBotNames = new JList();
  JScrollPane jScrollPane1 = new JScrollPane();
  JTree jTThreads = new JTree();
  JTextArea jTTournamentID = new JTextArea();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JTextArea jTGraphicPath = new JTextArea();




  public BForumPanel(JPanel pPanel,int WIDTH,int HEIGHT)
  {
    try
    {
      pWidth = WIDTH;
      pHeight = HEIGHT;
      parentPanel = pPanel;
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception
  {

    jTThreads.setRootVisible(false);
    jTThreads.addMouseListener(new java.awt.event.MouseAdapter()
    {

      public void mouseClicked(MouseEvent e)
      {
        jTThreads_mouseClicked(e);
      }
    });




    this.setLayout(null);
    //this.setSize(pWidth,pHeight);
    this.setSize(new Dimension(569, 506));


    this.setLayout(null);
    panelBorder = BorderFactory.createEtchedBorder();
    this.setBorder(panelBorder);

    //  Setup Table

    jLBotNames.addMouseListener(new java.awt.event.MouseAdapter()
    {

      public void mouseClicked(MouseEvent e)
      {
        jLBotNames_mouseClicked(e);
      }
    });

    jTInfo.setLineWrap(true);
    jTInfo.setWrapStyleWord(true);
    jTInfo.setBounds(new Rectangle(279, 277, 280, 73));

    jBSubmit.setToolTipText("Submit bots to tournaments");
    jBSubmit.setText("SUBMIT");
    jBSubmit.setBounds(new Rectangle(46, 411, 100, 25));
    jBSubmit.addMouseListener(new java.awt.event.MouseAdapter()
    {

      public void mouseClicked(MouseEvent e)
      {
        jBSubmit_mouseClicked(e);
      }
    });


    jBUpdate.setToolTipText("Submit bots to tournaments");
    jBUpdate.setText("UPDATE");
    jBUpdate.setBounds(new Rectangle(274, 234, 100, 25));
    jBUpdate.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        jBUpdate_actionPerformed(e);
      }
    });

   


    jLtournHeader.setBounds(new Rectangle(188, 9, 371, 19));
    jLtournHeader.setText("Available Tournaments");
    jLtournHeader.setHorizontalAlignment(SwingConstants.CENTER);
    jLtournHeader.setHorizontalTextPosition(SwingConstants.LEFT);
    jSBotNames.setBounds(new Rectangle(278, 359, 161, 107));
    jScrollPane1.setBounds(new Rectangle(269, 48, 250, 168));

    jTTournamentID.setBounds(new Rectangle(48, 277, 78, 26));
    jLabel1.setText("Tournament ID");
    jLabel1.setBounds(new Rectangle(45, 246, 104, 21));
    jLabel2.setText("Graphic Path");
    jLabel2.setBounds(new Rectangle(45, 325, 111, 21));
    jTGraphicPath.setBounds(new Rectangle(47, 354, 175, 27));
    this.add(jLtournHeader, null);
    this.add(jTInfo, null);
    this.add(jLAccBal, null);
    this.add(jBRemove, null);
    this.add(jSBotNames, null);
    this.add(jScrollPane1, null);
    this.add(jTTournamentID, null);
    this.add(jLabel1, null);
    this.add(jLabel2, null);
    this.add(jTGraphicPath, null);
    this.add(jBSubmit, null);
    this.add(jBUpdate, null);
    jScrollPane1.getViewport().add(jTThreads, null);
    jSBotNames.getViewport().add(jLBotNames, null);
    jLtournHeader.setBounds(new Rectangle(100, 9, 460, 19));
    jLAccBal.setBounds(new Rectangle(279, 482, 147, 18));


  }

  void jBUpdate_actionPerformed(ActionEvent e)
  {

    DefaultMutableTreeNode d = (DefaultMutableTreeNode)jTThreads.getLastSelectedPathComponent();
    SForumThread lastSelectedComponent = (SForumThread)d.getUserObject();
    BDebug.print("Selected Object ID: " +  lastSelectedComponent.id);

    SForum forum = (SForum)jLBotNames.getSelectedValue();
    Vector v = new Vector();

    Integer forumID = new Integer(forum.forumID);
    Integer parentThread = new Integer(lastSelectedComponent.id);

    v.addElement(forumID);
    v.addElement(parentThread);
    v.addElement("RE: "+lastSelectedComponent.subject);
    v.addElement(jTInfo.getText());

    roboforge.internal.BApplicationFrame bAFrame = (roboforge.internal.BApplicationFrame)this.getParent().getParent();
    SResponseWrapper responseWrapper = null;
    try
    {

      // Get the response
      BRequestDescriptor reqDesc = new BRequestDescriptor("AFE",((BFightPanel)parentPanel).loginId,((BFightPanel)parentPanel).password,((BFightPanel)parentPanel).clientPubKey,BGlobal.URLSGATEWAY);

      responseWrapper = SServerAccess.getServerResponse(reqDesc,v);

      if (responseWrapper.getResponseType().equals("AFE"))
      {
        // All is ok
        bAFrame.statusText.setText("Entry Added");

      }
      else if(responseWrapper.getResponseType().equals("ERR"))
      {
        // A Server Login Response
        bAFrame.statusText.setText("Couldn't add Entry: " + responseWrapper.getResponseObject());
      }
      else
      {
        // A Server Login Response
        bAFrame.statusText.setText("Unknown Response");
      }
    }
    catch (Exception e1)
    {
      bAFrame.statusText.setText("Couldn't add Entry: " + e1.getMessage());
      System.err.println(e1.getMessage());
    }
  }

  void jLBotNames_mouseClicked(MouseEvent e)
  {
    if(e.getClickCount() == 2)
    {
      SForum forum = (SForum)jLBotNames.getSelectedValue();
      BDebug.print(forum.forumPurpose);

      Integer forumId = new Integer(forum.forumID);
      // Get and set the Tree for the selected forum
      // Download the tournament information


      roboforge.internal.BApplicationFrame bAFrame = (roboforge.internal.BApplicationFrame)this.getParent().getParent();
      SResponseWrapper responseWrapper = null;
      try
      {

        // Get the response
        BRequestDescriptor reqDesc = new BRequestDescriptor("GFT",((BFightPanel)parentPanel).loginId,((BFightPanel)parentPanel).password,((BFightPanel)parentPanel).clientPubKey,BGlobal.URLSGATEWAY);
        responseWrapper = SServerAccess.getServerResponse(reqDesc,forumId);

        if (responseWrapper.getResponseType().equals("GFT"))
        {
          // All is ok
          DefaultTreeModel treeModel = (DefaultTreeModel)responseWrapper.getResponseObject();
          jTThreads.setModel(treeModel);
          //lastFTree.setModel(treeModel);

        }
        else if(responseWrapper.getResponseType().equals("ERR"))
        {
          // A Server Login Response
          bAFrame.statusText.setText("Couldn't get Forums: " + responseWrapper.getResponseObject());
        }
        else
        {
          // A Server Login Response
          bAFrame.statusText.setText("Unknown Response");
        }
      }
      catch (Exception e1)
      {
        bAFrame.statusText.setText("Couldn't get Forums: " + e1.getMessage());
        System.err.println(e1.getMessage());
      }

    }
  }

  
 

  public void setForums()
  {
    // Download the tournament information
    roboforge.internal.BApplicationFrame bAFrame = (roboforge.internal.BApplicationFrame)this.getParent().getParent();
    SResponseWrapper responseWrapper = null;
    try
    {

      // Get the response

      BRequestDescriptor reqDesc = new BRequestDescriptor("GFI",((BFightPanel)parentPanel).loginId,((BFightPanel)parentPanel).password,((BFightPanel)parentPanel).clientPubKey,BGlobal.URLSGATEWAY);

      responseWrapper = SServerAccess.getServerResponse(reqDesc,null);

      if (responseWrapper.getResponseType().equals("GFI"))
      {

        // All is ok
        Vector forumNames = (Vector)responseWrapper.getResponseObject();
        BDebug.print("****** Number of Forums: " + forumNames.size());
        jLBotNames.setListData(forumNames);

      }
      else if(responseWrapper.getResponseType().equals("ERR"))
      {
        // A Server Login Response
        bAFrame.statusText.setText("Couldn't get Forums: " + responseWrapper.getResponseObject());
      }
      else
      {
        // A Server Login Response
        bAFrame.statusText.setText("Unknown Response");
      }
    }
    catch (Exception e)
    {
      bAFrame.statusText.setText("Couldn't get Forums: " + e.getMessage());
      System.err.println(e.getMessage());
    }
  }

 


  // LISTENER HANDLERS


  void jTThreads_mouseClicked(MouseEvent e)
  {
    DefaultMutableTreeNode d = (DefaultMutableTreeNode)jTThreads.getLastSelectedPathComponent();
    SForumThread lastSelectedComponent = (SForumThread)d.getUserObject();
    BDebug.print("Thread ID: " + lastSelectedComponent.id);

    roboforge.internal.BApplicationFrame bAFrame = (roboforge.internal.BApplicationFrame)this.getParent().getParent();
    SResponseWrapper responseWrapper = null;
    try
    {
      BDebug.print("Click Count : " + e.getClickCount());

      // Get the response
      BRequestDescriptor reqDesc = new BRequestDescriptor("GTD",((BFightPanel)parentPanel).loginId,((BFightPanel)parentPanel).password,((BFightPanel)parentPanel).clientPubKey,BGlobal.URLSGATEWAY);
      responseWrapper = SServerAccess.getServerResponse(reqDesc,new Integer(lastSelectedComponent.id));

      if (responseWrapper.getResponseType().equals("GTD"))
      {
        // All is ok
        String threadDetails = (String)responseWrapper.getResponseObject();
        jTInfo.setText(threadDetails);
      }
      else if(responseWrapper.getResponseType().equals("ERR"))
      {
        // A Server Login Response
        bAFrame.statusText.setText("Couldn't get Details: " + responseWrapper.getResponseObject());
      }
      else
      {
        // A Server Login Response
        bAFrame.statusText.setText("Unknown Response");
      }

    }
    catch (Exception e3)
    {
      bAFrame.statusText.setText("Couldn't get Details: " + e3.getMessage());
      System.err.println(e3.getMessage());
    }
  }

  void jBSubmit_mouseClicked(MouseEvent e)
  {


    roboforge.internal.BApplicationFrame bAFrame = (roboforge.internal.BApplicationFrame)this.getParent().getParent();
    SResponseWrapper responseWrapper = null;
    try
    {
      Integer tournamentID = new Integer(jTTournamentID.getText());

      // Create the ImageIcon turn it into a byte array and pump it up to the Server
      //ImageIcon imageSponsor = new ImageIcon(jTGraphicPath.getText());

      FileInputStream fIS = new FileInputStream(jTGraphicPath.getText());


        // Open a file stream to save the BLOB data
        ByteArrayOutputStream l_fileOutStream = new ByteArrayOutputStream();

        // Read from the BLOB data input stream, and write to the file output stream
        byte[] l_buffer = new byte[10]; // buffer holding bytes to be transferred
        int l_nbytes = 0;  // Number of bytes read
        while ((l_nbytes = fIS.read(l_buffer)) != -1) // Read from BLOB stream
        l_fileOutStream.write(l_buffer,0,l_nbytes); // Write to file stream

        byte[] imageBytes = l_fileOutStream.toByteArray();

        fIS.close();


      // Turn the image into an array of bytes
      //byte[] imageBytes = SServerAccess.objectToByteArray(image);

      BDebug.print("Size of Graphic " + imageBytes.length);

      // Create and populate the vector
      Vector v = new Vector();

      v.addElement(tournamentID);
      v.addElement(imageBytes);

      // Get the response
      BRequestDescriptor reqDesc = new BRequestDescriptor("STG",((BFightPanel)parentPanel).loginId,((BFightPanel)parentPanel).password,((BFightPanel)parentPanel).clientPubKey,BGlobal.URLSGATEWAY);
      responseWrapper = SServerAccess.getServerResponse(reqDesc,v);

      if (responseWrapper.getResponseType().equals("STG"))
      {
        // All is ok

      }
      else if(responseWrapper.getResponseType().equals("ERR"))
      {
        // A Server Login Response
        bAFrame.statusText.setText("Couldn't get Details: " + responseWrapper.getResponseObject());
      }
      else
      {
        // A Server Login Response
        bAFrame.statusText.setText("Unknown Response");
      }
    }
    catch (Exception e1)
    {
      System.out.println(e1.getMessage());
    }
  }*/
}
