package roboforge;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.sql.*;
import java.util.Properties;



public class SProcessDownloadRequest extends SHttpServletJXGB
{

  //String html = "";
  //Initialize global variables
  public void init(ServletConfig config) throws ServletException
  {
    super.init(config);

    try
    {
      // Code to test the generation
      /*DataInputStream in =
        new DataInputStream(
          new BufferedInputStream(
            new FileInputStream("D:/Roboforge/betainstall.htm")));

      String s = new String();
      while ((s = in.readLine()) != null)
        html += s + "\n";
      in.close(); */

      /*
      No Longer Needed
      BufferedReader br =
        new BufferedReader(new FileReader("D:/Roboforge/salesdownload.htm"));

      String s = new String();
      while ((s = br.readLine()) != null)
        html += s + "\n";
      br.close();*/

      //System.out.println(html);
    }
    catch (Exception e)
    {
      System.out.println("Error: " + e.getMessage());
    }


  }

  //Process the HTTP Get request
  public void doGet(HttpServletRequest request,HttpServletResponse response) throws ServletException, IOException
  {
    doPost(request, response);
  }
  
  //Process the HTTP Post request
  public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
  {
    // Taken out 4/07/00 As now doing redirect again
    //response.setStatus(HttpServletResponse.SC_MOVED_PERMANENTLY);

    Connection con = null;
    String email = "";
    String regKey = "";
    Statement statement = null;
    ResultSet rs = null;

    try
    {

     // Code to track down the null parameter bug
      if (request == null)
      {
        System.err.println("SProcessDownloadRequest: Request is NULL");
        response.sendRedirect("http://www.roboforge.net/error.htm");
        return;
      }
      else
      {
        if (request.getParameter("EMAIL")== null || request.getParameter("REGKEY")== null)
        {
          // This condition will most likely be reached if a
          // search Robot attempts to link to www.roboforge.net/Servlets/SPreRegisterServlet
          // Get them to contact roboforge
          System.err.println("SProcessDownloadRequest: NULL EMAIL or REGKEY");
          response.sendRedirect("http://www.roboforge.net/dlerr1.htm");
          return;
        }
      }

      if ((request.getParameter("EMAIL").equals("")|| (request.getParameter("REGKEY").equals(""))))
      {
        // An empty string for either the login or password get them to reenter
        System.err.println("SProcessDownloadRequest: EMPTY EMAIL or REGKEY");
        response.sendRedirect("http://www.roboforge.net/dlerr1.htm");
        return;
      }

      email = request.getParameter("EMAIL").trim();
      regKey = request.getParameter("REGKEY").trim();

      if (regKey.length()!= 11)
      {
        // Not long enough, suggest that they enter the regCode exactly as given to them including the hyphens
        System.err.println("SProcessDownloadRequest: REGKEY LENGTH INCORRECT.  Email: " + email + " RegKey: " + regKey + " KeyLength: " + regKey.length());
        response.sendRedirect("http://www.roboforge.net/dlerr1.htm");
        return;
      }

      // Determine if it's a valid email address/regKey combination
      con = getDatabaseConnection();

      statement = con.createStatement();
      String sql = "SELECT id, download_count FROM ACCOUNT WHERE LOWER(email) = LOWER('" +  email + "')";
      sql += " AND LOWER(registration_key) = LOWER('" + regKey + "') AND status <> 'D'";
      rs = statement.executeQuery(sql);

      //rs.next();

      //int count = rs.getInt("COUNT");

      if (rs.next())
      {
        // Valid password login Combination
        long accountID = rs.getLong("id");
        int downloadCount = rs.getInt("download_count");

        rs.close();
        statement.close();

        // Check to see that they haven't exceeded their download quota
        if (downloadCount >= 10)
        {
          // Exceeded download count
          System.err.println("SProcessDownloadRequest: EXCEEDED QUOTA.  Email: " + email + " RegKey: " + regKey);
          response.sendRedirect("http://www.roboforge.net/dlerr2.htm");
          return;
        }

        // Update the number of downloads
        sql = "UPDATE ACCOUNT SET download_count = " + (downloadCount + 1);
        sql += " WHERE id = " + accountID;

        statement = con.createStatement();
        statement.executeUpdate(sql);

        statement.close();

        
        /*
        No Longer Needed

        response.setContentType("text/html");
        PrintWriter out = response.getWriter();

        out.print(html);
        */
        response.sendRedirect("http://www.roboforge.net/buttons/_notes/xp3qu8905x789345rd32zpq/roboforge.exe");
        return;

        //response.sendRedirect("http://www.roboforge.net/suberr.htm");
        //return;
      }
      else
      {

        rs.close();
        statement.close();
        System.err.println("SProcessDownloadRequest: INVALID COMBO.  Email: " + email + " RegKey: " + regKey);
        // InValid password login Combination redirect to invalid page
        response.sendRedirect("http://www.roboforge.net/dlerr1.htm");
        return;
      }
    }
    catch (Exception e)
    {
      System.err.println("Error SProcessDownloadRequest.doPost: "+ e.getMessage());

      //response.sendRedirect ("\\\\EDGE/Edge/Website/Mainsubok.htm");
      //response.sendRedirect(SGlobal.WEB_PAGE_LOCATION +"/subok.htm");
      response.sendRedirect("http://www.roboforge.net/error.htm");
      //response.setHeader("Location","/subok.htm");
      return;
      //response.sendRedirect("http://server.roboforge.com/subok.htm");
    }
    finally
    {
      try
      {
        if (con!= null)
        {
          myBroker.freeConnection(con);
        }

        if (rs != null)
          rs.close();
        if (statement != null)
          statement.close();

      }
      catch(Exception e3)
      {
        System.err.println("Error SProcessDownloadRequest.myBroker.freeConnection: "+e3.getMessage());
      }
    }


  }
  private Connection getDatabaseConnection()
  {
    Connection con = null;
    try
    {
      con = myBroker.getConnection();  
      /*
      Class.forName ("oracle.jdbc.driver.OracleDriver");
      con = DriverManager.getConnection("jdbc:oracle:thin:@hugh:1521:edge", "edge", "edge");
      */
      //Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
      //con = DriverManager.getConnection("jdbc:odbc:Testy");
    }

    catch (Exception sqle)
    {
      System.err.println("Error SProcessDownloadRequest.getDatabaseConnection: " + sqle.getMessage());
    }
  return con;
  }
  //Get Servlet information
  public String getServletInfo()
  {
    return "roboforge.SProcessDownloadRequest Information";
  }
}
