package roboforge.ai.expressions;

import roboforge.ai.memory.*;
import roboforge.ai.values.*;


public class BMemoryRef extends BTerminal
{

  // Serialization ID.
  // -----------------------------------------------------------
  static final long serialVersionUID = -1L;

  protected BMemoryItem item;

  public BMemoryRef(BMemoryItem item)
  {
    super();
    this.item = item;
  }

  public BValue evaluate()
    { return item.getValue(); }

  public int getType()
    { return item.getType(); }

  public String toString()
    { return item.toString(); }

}
