package roboforge.ai.expressions;

import roboforge.ai.values.*;


public class BNamedConstant extends BConstant
{

  // Member variables...
  // -------------------------------------------------------------

  protected String name;


  // Constructors...
  // -------------------------------------------------------------

  public BNamedConstant(String name, BValue value)
  {
    super(value);
    this.name = name;
  }

  public BNamedConstant(BNamedConstant n)
  {
    super(n);
    this.name = n.name;
  }

  public Object clone()
    { return new BNamedConstant(this); }


  //
  // -------------------------------------------------------------

  public String toString()
    { return name; }

}
