package roboforge.net.data;

import roboforge.util.data.*;


public class BAccountData extends BAbstractAtom
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Constructor...
  // -------------------------------------------------------------

  public BAccountData(long id)
    { super(id); }


  // Type definition...
  // -------------------------------------------------------------

  public int getType()
    { return BDataTypes.ACCOUNT; }


  // Data fields...
  // -------------------------------------------------------------

  public String  loginID;
    // TODO: Can the user change loginID?
  
  public String  password;
    // If no password change requested, this field will
    // be null or contain the empty string.

  public String  name;
  public String  designerName;
  public String  registrationCode;

  public String  address1;
  public String  address2;
  public String  city;
  public String  state;
  public String  country;
  public String  postCode;

  public String  email;

  public String  blurb;
    // This will be visible to all other account holders.

  public float   currentBalance;
  public float   winningsBalance;

}