package roboforge.net.data;

import roboforge.util.data.*;


public class BErrorData extends BAbstractAtom
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Constructor...
  // -------------------------------------------------------------

  public BErrorData(long id)
    { super(id); }

  public BErrorData(String shortDescription)
  {
    // TODO: Is this a valid ID?
    super(0);
    this.shortDescription = shortDescription;
  }

  
  // Type definition...
  // -------------------------------------------------------------

  public int getType()
    { return BDataTypes.ERROR; }


  // Data fields...
  // -------------------------------------------------------------

  public String shortDescription;
  public String longDescription;
  public String resolution;
  public int    typeID;
  public Long   dataID;
  
  
  // Accessor methods...
  // -------------------------------------------------------------
  
  public String toString()
    { return shortDescription; }
  
}
