package roboforge.particles.forces;

import javax.vecmath.*;
import roboforge.particles.*;


public interface BParticleForce
{

  public void apply(BParticle p, float t, Vector3f f);
    // Calculates force on a particle at time t.
    // Adds result to the 3d vector 'f'.

  public void update(float t);
    // Updates this force object.

}
