package roboforge.ui.components;

import java.awt.Component;
import javax.swing.JCheckBox;

public class BCheckBox extends JCheckBox
{

  // Constructor...
  // -------------------------------------------------------------

  public BCheckBox(BUIResources res, String key)
  {
    super();
    initializeUI(res, key);
  }

  public BCheckBox(String text)
  {
    super(text);
    initializeUI(null, null);
  }

  public BCheckBox()
  {
    super();
    initializeUI(null, null);
  }

  // Visual Initialization methods...
  // -------------------------------------------------------------

  public void initializeUI(BUIResources res, String key)
  {
    if (res != null)
      res.initComponent(this, key);

    setOpaque(false);

    // Set centered alignment, for correct BoxLayout display...
    setAlignmentX(Component.CENTER_ALIGNMENT);
    setAlignmentY(Component.CENTER_ALIGNMENT);
  }

}