package roboforge.ui.components;

import roboforge.BGlobal;

import java.awt.Dimension;
import javax.swing.*;
import javax.swing.text.*;



public class BTextArea extends JTextArea
{
  
  // Constructor.
  // -------------------------------------------------------------

  public BTextArea(BUIResources res, String key)
  {
    super();
    initializeUI(res, key);
  }

  public BTextArea()
    { this(null, null); }


  public void initializeUI(BUIResources res, String key)
  {
    if (res != null)
    {
      res.initComponent(this, key);

      String text = res.getString(key+ ".text");
      if (text != null)
        setText(text);
    }
  }


  /*
  
  int maxSize = Short.MAX_VALUE;
  
  public int getFieldSize()
    { return maxSize; }

  public void setFieldSize(int i)
  {
    maxSize = i;

  }


  // Document model stuff.
  // -------------------------------------------------------------


  protected Document createDefaultModel()
    { return new GuardedTextDocument(); }

  protected class GuardedTextDocument extends PlainDocument
  {
    public void insertString(int offset, String str, AttributeSet a)
      throws BadLocationException
    {
      int length = getLength();

      // Trivial rejection...
      if ((str == null) || (length >= maxSize))
        { getToolkit().beep(); return; }
      
      super.insertString(offset, str, a);
    }

  }

  */

}


