package roboforge.ui.events;

import java.util.*;

public class BProgressEvent extends EventObject
{
  /**
	 * 
	 */
	private static final long serialVersionUID = -1L;
protected double progress;

  public BProgressEvent(Object source, double progress)
  {
    super(source);
    this.progress = progress;
  }

  public synchronized void setProgress(double p)
    { this.progress = p; }

  public synchronized double getProgress()
    { return progress; }

}