package roboforge.util.io;

import java.io.*;



public class BIOUtils
{
  
  // Integer read/write methods...
  // -----------------------------------------------------------
  
  public static int readInt(InputStream in) throws IOException
  {
    byte[] is = new byte[4];
    
    in.read(is);
    
    return
      ((is[0] & 0xFF) << 24) +
      ((is[1] & 0xFF) << 16) +
      ((is[2] & 0xFF) <<  8) +
      ((is[3] & 0xFF) <<  0);
  }
  
  public static void writeInt(OutputStream out, int i) throws IOException
  {
    byte[] is = new byte[4];
    
    is[0] = (byte) (i >>> 24);
    is[1] = (byte) (i >>> 16);
    is[2] = (byte) (i >>>  8);
    is[3] = (byte) (i >>>  0);
    
    out.write(is);
  }
  
}
