package roboforge;

//: BComponentEditorInfoB.java

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
//import java.io.*;

public class BComponentEditorInfoBackup extends JPanel 
{

/*

* Description: Display panel of Component Stats and general info.

* Example:
* Modification History ( Name, Date, Notes ):
                        DJG 13-Apr-99
                        HSC 15-Apr-99
                        Changed from BComponentInfo for my own
                        Nefarious purposes.
                        HSC 19-Apr-99
                        Added support for BEnergyGenerator.

*/

  /**
	 * 
	 */
	private static final long serialVersionUID = -1L;
static int FHEIGHT = 20;
  static int GAP = 5;
  static int MARGIN = 50;
  Float fValue;
  // Main Component
  JTextField name = new JTextField();
  JTextArea details = new JTextArea();
  JTextField price = new JTextField();
  public JTextField weight = new JTextField();
  public JTextField damageMax = new JTextField();

  JTextField autoTextureGen = new JTextField();



  //JTextField damageDealStriking = new JTextField();
  //JTextField damageResistStriking = new JTextField();
  //JTextField damageResistPiercing = new JTextField();
  //JTextField damageResistCrushing = new JTextField();
  //JTextField damageResistEnergy = new JTextField();
  //JTextField energyUsage = new JTextField();
  JTextField ambientSound = new JTextField();

  // Cpu
  //JTextField cpuMemory = new JTextField();
  JTextField cpuCyclesPerSecond = new JTextField();

  //BWheel
  JTextField wheelRadius = new JTextField();

  // Joint
  JTextField jointPowerOutput = new JTextField();
  //JTextField jointEnergyUsage = new JTextField();
  JTextField jointMaxVelocity = new JTextField();
  JTextField jointMaxAcceleration = new JTextField();

  JTextField jointFreedomMax = new JTextField();
  JTextField jointFreedomMin = new JTextField();

  //JTextField acceleration = new JTextField();
     // Sensor
  JTextField sensorRange = new JTextField();
  JTextField sensorScope = new JTextField();
  JTextField sensorAccuracy = new JTextField();
  JTextField glow = new JTextField();

  // Weapon
  JTextField strikingMass = new JTextField();
  JTextField damageBonus = new JTextField();
  JTextField damageResistance = new JTextField();

  // Shielding
  JTextField damageResist = new JTextField();

  // Energy Generator
  JTextField energyCapacity = new JTextField();
  JTextField energyOutputRate = new JTextField();

  JTextField enableLighting = new JTextField();

  // Chassis
  //JTextField chassisEnergyUsage = new JTextField();
  JTextField chassisPowerOutput = new JTextField();
  JTextField loadCapacity = new JTextField();
  JTextField chassisMaxVelocity = new JTextField();
  JTextField sidewaysMaxVelocity = new JTextField();
  JTextField backwardsMaxVelocity = new JTextField();
  JTextField rotateSpeed = new JTextField();
  JTextField chassisAcceleraion = new JTextField();
  JTextField chassisRotateAcceleration = new JTextField();
  JTextField chassisMaxRotateVelocity = new JTextField();
  JTextField chassisMaxBalancedTorque = new JTextField();

  JTextField chassisHoverHeight = new JTextField();



  // Variable Labels
  JLabel label1 = new JLabel();
  JLabel label2 = new JLabel();
  JLabel label3 = new JLabel();
  JLabel label4 = new JLabel();
  JLabel label5 = new JLabel();
  JLabel label6 = new JLabel();
  JLabel label7 = new JLabel();
  JLabel label8 = new JLabel();
  JLabel label9 = new JLabel();
  JLabel label10 = new JLabel();
  JLabel label11 = new JLabel();


  // Ratio Labels
  JLabel ratio1 = new JLabel("===Value (Std)===");
  JLabel ratio2 = new JLabel();
  JLabel ratio3 = new JLabel();
  JLabel ratio4 = new JLabel();
  JLabel ratio5 = new JLabel();
  //JLabel ratio6 = new JLabel();
  //JLabel ratio7 = new JLabel();
  //JLabel ratio8 = new JLabel();
  //JLabel ratio9 = new JLabel();
  //JLabel ratio10 = new JLabel();
  //JLabel ratio11 = new JLabel();
  JLabel ratio12 = new JLabel();
  JLabel ratio13 = new JLabel();
  JLabel ratio14 = new JLabel();
  JLabel ratio15 = new JLabel();
  JLabel ratio16 = new JLabel();
  JLabel ratio17 = new JLabel();
  JLabel ratio18 = new JLabel();
  JLabel ratio19 = new JLabel();
  JLabel ratio20 = new JLabel();
  JLabel ratio21 = new JLabel();
  JLabel ratio22 = new JLabel();
  JLabel ratio23 = new JLabel();


  // Jlabel
  JLabel componentTypeName;

  // Other
  BComponent component;
  BComponent stdComponent;
  int ratioCount = 0;
  float recPrice = 0; // Recommended Price
  int polyCount = 0;
  float polyPrice = 0; // Extra to get min Cost/Poly Ratio correct
  static float MIN_COST_POLY_RATIO = 7.5f; // 30,000 cr / 4000 polys
  JLabel polyCnt = new JLabel("Polys: 0");
  JLabel polyCost = new JLabel("");
  JLabel ratioTotal = new JLabel("Price: 0");

  public BComponentEditorInfoBackup(boolean editable)
  {
    int pWidth = 565;
    int pHeight = 520;
    this.setLayout(new GridBagLayout());
    this.setSize(pWidth,pHeight);
    GridBagConstraints c = new GridBagConstraints();
    c.gridx = 1;
    c.gridy = 0;
    c.gridheight = 1;
    //c.gridwidth = GridBagConstraints.REMAINDER;
    c.gridwidth = 1;
    c.fill = GridBagConstraints.BOTH;
    c.weightx = 1;

    // Name
    name.setText("");
    name.setEditable(editable);
    name.setVisible(true);
    this.add(name,c);

    // Details
    c.gridy = GridBagConstraints.RELATIVE;
    c.gridheight = 6;
    details.setText("");
    details.setRows(6);
    details.setLineWrap(true);
    details.setEditable(editable);
    details.setVisible(true);
    this.add(details,c);
    c.gridheight = 1;

    // Price
    price.setText("");
    price.setEditable(editable);
    price.setVisible(true);
    this.add(price,c);

    // Weight
    weight.setText("");
    weight.setEditable(editable);
    weight.setVisible(true);
    this.add(weight,c);

    // Maximum Damage
    damageMax.setText("");
    damageMax.setEditable(editable);
    damageMax.setVisible(true);
    this.add(damageMax,c);

    autoTextureGen.setText("");
    autoTextureGen.setEditable(editable);
    autoTextureGen.setVisible(true);
    this.add(autoTextureGen,c);




    /*
    // Striking Damage
    damageDealStriking.setText("");;
    damageDealStriking.setEditable(editable);
    damageDealStriking.setVisible(true);
    this.add(damageDealStriking,c);

    // Striking Resist
    damageResistStriking.setText("");
    damageResistStriking.setEditable(editable);
    damageResistStriking.setVisible(true);
    this.add(damageResistStriking,c);

    // Piercing Resist
    damageResistPiercing.setText("");
    damageResistPiercing.setEditable(editable);
    damageResistPiercing.setVisible(true);
    this.add(damageResistPiercing,c);

    // Crushing Resist
    damageResistCrushing.setText("");
    damageResistCrushing.setEditable(editable);
    damageResistCrushing.setVisible(true);
    this.add(damageResistCrushing,c);

    // Energy Resist
    damageResistEnergy.setText("");
    damageResistEnergy.setEditable(editable);
    damageResistEnergy.setVisible(true);
    this.add(damageResistEnergy,c);

    // Energy Usage
    energyUsage.setText("");
    energyUsage.setEditable(false);
    energyUsage.setVisible(true);
    this.add(energyUsage,c);
    */
    
    ambientSound.setText("");
    ambientSound.setEditable(editable);
    ambientSound.setVisible(true);
    ambientSound.setEditable(false);
    ambientSound.addMouseListener(
      new MouseAdapter()
      {
         
          public void mouseClicked(MouseEvent e)
          {
            String suffix = BGlobal.SOUNDSUFFIX;
            suffix = suffix.substring(1,suffix.length());

            JFileChooser fileDialog = new JFileChooser(BGlobal.SOUNDPATH);

            int option = fileDialog.showOpenDialog(null);

            if (option == JFileChooser.APPROVE_OPTION)
            {
              // Save the Component
              ambientSound .setText( fileDialog.getSelectedFile().getPath().substring(BGlobal.SOUNDPATH.length() )       ) ;
            }


          }

      }

    );

    this.add(ambientSound,c);


    wheelRadius.setText("");
    wheelRadius.setEditable(editable);
    wheelRadius.setVisible(false);
    this.add(wheelRadius,c);


    // CPU Memory
    //cpuMemory.setText("");
    //cpuMemory.setEditable(editable);
    //cpuMemory.setVisible(false);
    //this.add(cpuMemory,c);

    // CPU Cycles Per Second
    cpuCyclesPerSecond.setText("");
    cpuCyclesPerSecond.setEditable(editable);
    cpuCyclesPerSecond.setVisible(false);
    this.add(cpuCyclesPerSecond,c);


    // Joint Power Output
    jointPowerOutput.setText("");
    jointPowerOutput.setEditable(editable);
    jointPowerOutput.setVisible(false);
    this.add(jointPowerOutput,c);

    /*
    // Joint Energy Usage
    jointEnergyUsage.setText("");
    jointEnergyUsage.setEditable(editable);
    jointEnergyUsage.setVisible(false);
    jointEnergyUsage.setEnabled(false);
    this.add(jointEnergyUsage,c);
    */

     // Joint Max Velocity
    jointMaxVelocity.setText("");
    jointMaxVelocity.setEditable(editable);
    jointMaxVelocity.setVisible(false);
    this.add(jointMaxVelocity,c);

      // Joint Max Acceleration
    jointMaxAcceleration.setText("");
    jointMaxAcceleration.setEditable(editable);
    jointMaxAcceleration.setVisible(false);
    this.add(jointMaxAcceleration,c);

    


    // Sensor Range
    sensorRange.setText("");
    sensorRange.setEditable(editable);
    sensorRange.setVisible(false);
    this.add(sensorRange,c);

    // Sensor Scope
    sensorScope.setText("");
    sensorScope.setEditable(editable);
    sensorScope.setVisible(false);
    this.add(sensorScope,c);

    //Sensor Accuracy
    sensorAccuracy.setText("");
    sensorAccuracy.setEditable(editable);
    sensorAccuracy.setVisible(false);
    this.add(sensorAccuracy,c);

    //Sensor Glow
    glow.setText("");
    glow.setEditable(editable);
    glow.setVisible(false);
    this.add(glow,c);

    // Striking Mass
    strikingMass.setText("");
    strikingMass.setEditable(editable);
    strikingMass.setVisible(false);
    this.add(strikingMass,c);

    //Damage Dealt Bonus
    damageBonus.setText("");
    damageBonus.setEditable(editable);
    damageBonus.setVisible(false);
    this.add(damageBonus,c);

    //Damage Resistance
    damageResistance.setText("");
    damageResistance.setEditable(editable);
    damageResistance.setVisible(false);
    this.add(damageResistance,c);

    //Damage Resist - Striking
    damageResist.setText("");
    damageResist.setEditable(editable);
    damageResist.setVisible(false);
    this.add(damageResist,c);


    //Energy generator - Energy capacity.
    energyCapacity.setText("");
    energyCapacity.setEditable(editable);
    energyCapacity.setVisible(false);
    this.add(energyCapacity,c);

    //Energy generator - Energy output rate.
    energyOutputRate.setText("");
    energyOutputRate.setEditable(editable);
    energyOutputRate.setVisible(false);
    this.add(energyOutputRate,c);

    //Ornament - Energy output rate.
    enableLighting.setText("");
    enableLighting.setEditable(editable);
    enableLighting.setVisible(false);
    this.add(enableLighting,c);



    /*
    //Chassis - Energy Usage
    chassisEnergyUsage.setText("");
    chassisEnergyUsage.setEditable(editable);
    chassisEnergyUsage.setVisible(false);
    this.add(chassisEnergyUsage,c);
    */

    //Chassis - Power Output
    chassisPowerOutput.setText("");
    chassisPowerOutput.setEditable(editable);
    chassisPowerOutput.setVisible(false);
    this.add(chassisPowerOutput,c);

    //Chassis - Load Capacity
    loadCapacity.setText("");
    loadCapacity.setEditable(editable);
    loadCapacity.setVisible(false);
    this.add(loadCapacity,c);

    //Chassis - Max Velocity
    chassisMaxVelocity.setText("");
    chassisMaxVelocity.setEditable(editable);
    chassisMaxVelocity.setVisible(false);
    this.add(chassisMaxVelocity,c);

    //Chassis - Sideways Velocity
    sidewaysMaxVelocity.setText("");
    sidewaysMaxVelocity.setEditable(editable);
    sidewaysMaxVelocity.setVisible(false);
    this.add(sidewaysMaxVelocity,c);

    //Chassis - Backwards Velocity
    backwardsMaxVelocity.setText("");
    backwardsMaxVelocity.setEditable(editable);
    backwardsMaxVelocity.setVisible(false);
    this.add(backwardsMaxVelocity,c);

    //Chassis - Rotate Speed
    rotateSpeed.setText("");
    rotateSpeed.setEditable(editable);
    rotateSpeed.setVisible(false);
    this.add(rotateSpeed,c);


    //Chassis - chassisAcceleraion
    chassisAcceleraion.setText("");
    chassisAcceleraion.setEditable(editable);
    chassisAcceleraion.setVisible(false);
    this.add(chassisAcceleraion,c);

    //Chassis - chassisRotateAcceleration
    chassisRotateAcceleration.setText("");
    chassisRotateAcceleration.setEditable(editable);
    chassisRotateAcceleration.setVisible(false);
    this.add(chassisRotateAcceleration,c);

    //Chassis -chassisMaxRotateVelocity
    chassisMaxRotateVelocity.setText("");
    chassisMaxRotateVelocity.setEditable(editable);
    chassisMaxRotateVelocity.setVisible(false);
    this.add(chassisMaxRotateVelocity,c);

    //Chassis -chassisMaxBalancedTorque
    chassisMaxBalancedTorque.setText("");
    chassisMaxBalancedTorque.setEditable(editable);
    chassisMaxBalancedTorque.setVisible(false);
    this.add(chassisMaxBalancedTorque,c);

    //Chassis -chassisHoverHeight
    chassisHoverHeight.setText("");
    chassisHoverHeight.setEditable(editable);
    chassisHoverHeight.setVisible(false);
    this.add(chassisHoverHeight,c);




    // Joint Min Freedom
    jointFreedomMin.setText("");
    jointFreedomMin.setEditable(editable);
    jointFreedomMin.setVisible(false);
    this.add(jointFreedomMin,c);

    // Joint Max Freedom
    jointFreedomMax.setText("");
    jointFreedomMax.setEditable(editable);
    jointFreedomMax.setVisible(false);
    this.add(jointFreedomMax,c);

    /*
    // Joint Acceleration (calculated)
    acceleration.setText("");
    acceleration.setEditable(editable);
    acceleration.setVisible(false);
    acceleration.setEnabled(false);
    this.add(acceleration,c);
    */


    // Set Field Labels
    c.gridx = 0;
    c.gridy = 0;
    c.weightx = 1;
    c.fill = GridBagConstraints.BOTH;
    c.gridheight = 1;
    c.gridwidth = 1;

    componentTypeName = new JLabel("Name:");
    this.add(componentTypeName,c);
    c.gridy = GridBagConstraints.RELATIVE;
    c.gridheight = 6;
    this.add(new JLabel("Details:"),c);
    c.gridheight = 1;
    this.add(new JLabel("Price: $ "),c);
    this.add(new JLabel("Weight: Kg "),c);
    this.add(new JLabel("Max Dmg: Units "),c);
    //this.add(new JLabel("All shapes are convex T|F"),c);
    //this.add(new JLabel("Strike Dmg: Units per Kg/M/Sec "),c);
    //this.add(new JLabel("Strike Res: % "),c);
    //this.add(new JLabel("Pierce Res: % "),c);
    //this.add(new JLabel("Crush Res: % "),c);
    //this.add(new JLabel("Energy Res: % "),c);
    this.add(new JLabel("Warps Texture"),c);
    this.add(new JLabel("Ambient Sound Name: (File Path) "),c);
    //this.add(new JLabel("Destruct Sequence "), c);
    this.add(label1,c);
    this.add(label2,c);
    this.add(label3,c);
    this.add(label4,c);
    this.add(label5,c);
    this.add(label6,c);
    this.add(label7,c);
    this.add(label8,c);
    this.add(label9,c);
    this.add(label10,c);
    this.add(label11,c);

    // Add Ratios
    c.gridx = 2;
    c.gridy = 0;
    c.weightx = 1;
    c.fill = GridBagConstraints.BOTH;
    c.gridwidth = GridBagConstraints.REMAINDER;
    //c.gridwidth = 1;
    c.gridheight = 1;

    this.add(ratio1,c);
    c.gridy = GridBagConstraints.RELATIVE;
    c.gridheight = 6;
    this.add(ratio2,c);
    c.gridheight = 1;
    this.add(ratio3,c);
    this.add(ratio4,c);
    this.add(ratio5,c);
    //this.add(ratio6,c);
    //this.add(ratio7,c);
    //this.add(ratio8,c);
    //this.add(ratio9,c);
    //this.add(ratio10,c);
    //this.add(ratio11,c);
    this.add(ratio12,c);
    this.add(ratio13,c);
    this.add(ratio14,c);
    this.add(ratio15,c);
    this.add(ratio16,c);
    this.add(ratio17,c);
    this.add(ratio18,c);
    this.add(ratio19,c);
    this.add(ratio20,c);
    this.add(ratio21,c);
    this.add(ratio22,c);
    this.add(ratio23,c);
    this.add(polyCnt,c);
    this.add(polyCost,c);
    this.add(ratioTotal,c);

  }

  public void updateComponent()
  {
    component.setName(name.getText());
    component.setDetails(details.getText());
    component.price = Float.valueOf(price.getText()).floatValue();
    component.weight = Float.valueOf(weight.getText()).floatValue();
    component.damageMax = Integer.valueOf(damageMax.getText()).intValue();

    component.setAutoTextureGen(autoTextureGen.getText().equalsIgnoreCase("T"));

    //component.damageDealStriking = Float.valueOf(damageDealStriking.getText()).floatValue();
    //omponent.damageResistStriking = Integer.valueOf(damageResistStriking.getText()).intValue();
    //component.damageResistPiercing = Integer.valueOf(damageResistPiercing.getText()).intValue();
    //component.damageResistCrushing = Integer.valueOf(damageResistCrushing.getText()).intValue();
    //component.damageResistEnergy = Integer.valueOf(damageResistEnergy.getText()).intValue();
    //component.energyUsage = Float.valueOf(energyUsage.getText()).floatValue();

    component.setAmbientSoundName(ambientSound.getText() );

    if (component instanceof BCpu)
    {
      //((BCpu)component).setMemoryTime(Float.valueOf(cpuMemory.getText()).floatValue());
      ((BCpu)component).cpuCyclesPerSecond = Integer.valueOf(cpuCyclesPerSecond.getText()).intValue();
    }

     if (component instanceof BWheel)
    {
     // ((BWheel)component).setMemoryTime(Float.valueOf(wheelRadius.getText()).floatValue()    );
    }
    else if (component instanceof BJoint)
    {
      BJoint bJoint = (BJoint) component;
      bJoint.jointPowerOutput = Float.valueOf(jointPowerOutput.getText()).floatValue();
      //bJoint.jointEnergyUsage = Float.valueOf(jointEnergyUsage.getText()).floatValue();

      //bJoint.setAcceleration(Float.valueOf(acceleration.getText()).floatValue());
      bJoint.setMaxVelocity(Float.valueOf(jointMaxVelocity.getText()).floatValue());
      bJoint.setMaxAcceleration(Float.valueOf(jointMaxAcceleration.getText()).floatValue());



      bJoint.setFreedomBounds(Float.valueOf(jointFreedomMin.getText()).floatValue(),  Float.valueOf(jointFreedomMax.getText()).floatValue() );
    }

    if (component instanceof BSensor)
    {
      BSensor bSensor = (BSensor) component;
      bSensor.sensorRange = Integer.valueOf(sensorRange.getText()).intValue();
      bSensor.sensorScope = Integer.valueOf(sensorScope.getText()).intValue();
      bSensor.sensorAccuracy = Integer.valueOf(sensorAccuracy.getText()).intValue();


      if ( glow.getText().equals("t") || glow.getText().equals("T") )
        bSensor.glow = true;
      else
        bSensor.glow = false;



    }

    if (component instanceof BWeapon)
    {
      BWeapon bWeapon = (BWeapon) component;
      bWeapon.strikingMass = Float.valueOf(strikingMass.getText()).floatValue();
      bWeapon.setDamageBonus( Float.parseFloat(damageBonus.getText()) / 100f     );
      bWeapon.damageResistance = Integer.parseInt( damageResistance.getText() );
    }

    if (component instanceof BShielding)
    {
      BShielding bShielding = (BShielding) component;
      bShielding.setDamageResist( Integer.parseInt(damageResist.getText()) );
    }

    if (component instanceof BChassis)
    {
      BChassis bChassis = (BChassis) component;
      //bChassis.chassisEnergyUsage = Float.valueOf(chassisEnergyUsage.getText()).floatValue();
      bChassis.chassisPowerOutput = Float.valueOf(chassisPowerOutput.getText()).floatValue();
      bChassis.loadCapacity = Float.valueOf(loadCapacity.getText()).floatValue();
      bChassis.chassisMaxVelocity = Float.valueOf(chassisMaxVelocity.getText()).floatValue();
      bChassis.sidewaysMaxVelocity = Float.valueOf(sidewaysMaxVelocity.getText()).floatValue();
      bChassis.backwardsMaxVelocity = Float.valueOf(backwardsMaxVelocity.getText()).floatValue();
      bChassis.rotateSpeed = Float.valueOf(rotateSpeed.getText()).floatValue();
      bChassis.acceleration = Float.valueOf(chassisAcceleraion.getText()).floatValue();
      bChassis.rotateAcceleration =  Float.valueOf(chassisRotateAcceleration.getText()).floatValue();
      bChassis.maxRotateVelocity =  Float.valueOf(chassisMaxRotateVelocity.getText()).floatValue();
      bChassis.setMaxBalancedTorque( Float.valueOf(chassisMaxBalancedTorque.getText()).floatValue() );

      if (bChassis instanceof BHoverChassis)
        ((BHoverChassis)bChassis).setHeightInWorldUnits ( Float.parseFloat( chassisHoverHeight.getText() ) );


    }

    if (component instanceof BEnergyGenerator)
    {
      BEnergyGenerator bEnergyGenerator = (BEnergyGenerator) component;
      bEnergyGenerator.energyCapacity = Float.valueOf(energyCapacity.getText()).floatValue();
      bEnergyGenerator.energyOutputRate = Float.valueOf(energyOutputRate.getText()).floatValue();

    }
    if (component instanceof BArenaOrnament)
    {
     component.setEnableLighting(enableLighting.getText().equalsIgnoreCase("t")  );

    }

  }

  public void loadComponent(BComponent bComponent, BComponent stdComponent)
  {
    this.component = bComponent;
    this.stdComponent = stdComponent;
    if ( this.stdComponent == null )
      this.stdComponent = bComponent;
    componentTypeName.setText("Component Name:");
    setInvisible();
    name.setText(bComponent.getName());
    details.setText(bComponent.getDetails());
    price.setText(bComponent.price+"");

    price.setText(bComponent.price + "");
    weight.setText(bComponent.weight+"");
    damageMax.setText(bComponent.damageMax+"");

    polyCount = component.getPolyCount();


    if ( bComponent.getAutoTextureGen() )
       autoTextureGen.setText("T");
    else
      autoTextureGen.setText("F");

    //damageDealStriking.setText(bComponent.damageDealStriking+"");
    //damageResistStriking.setText(bComponent.damageResistStriking+"");
    //damageResistPiercing.setText(bComponent.damageResistPiercing+"");
    //damageResistCrushing.setText(bComponent.damageResistCrushing+"");
    //damageResistEnergy.setText(bComponent.damageResistEnergy+"");
    //energyUsage.setText(bComponent.energyUsage+"");

    ambientSound.setText(bComponent.getAmbientSoundName() );
    //destructSequence.setText(bComponent.getDestructSequenceName());

    if (bComponent instanceof BCpu)
    {
      componentTypeName.setText("Controller Name:");
      BCpu bCpu = (BCpu) bComponent;
      //cpuMemory.setText(bCpu.getMemoryTime() + "" );
      cpuCyclesPerSecond.setText(bCpu.cpuCyclesPerSecond+"");
      //label1.setText("Memory: Secs ");
      label1.setText("Speed: Decisions/Sec ");
      //cpuMemory.setVisible(true);
      cpuCyclesPerSecond.setVisible(true);

    }

    if (bComponent instanceof BWheel)
    {
      componentTypeName.setText("Wheel Name:");
      wheelRadius.setVisible(true);
      label1.setText("Radius");

    }
    else if (bComponent instanceof BJoint)
    {
      componentTypeName.setText("Joint Name:");
      BJoint bJoint = (BJoint) bComponent;

      jointPowerOutput.setText(bJoint.jointPowerOutput+"");
      //jointEnergyUsage.setText(bJoint.jointEnergyUsage+"");
      jointMaxVelocity.setText(bJoint.getMaxVelocity()+"");
      if ( bJoint.getMaxAcceleration() == 0 )
        jointMaxAcceleration.setText(((BJoint)stdComponent).getMaxAcceleration() + "" );
      else
        jointMaxAcceleration.setText(bJoint.getMaxAcceleration() + "" );
      jointFreedomMin.setText(bJoint.getFreedomMin() + "");
      jointFreedomMax.setText(bJoint.getFreedomMax() + "");
      //acceleration.setText(bJoint.getAcceleration() + "");

      label1.setText("Power: KW ");
      //label2.setText("Energy Use: W/Kg/(M | Rad)/Sec ");
      label2.setText("Max Velocity: (M/S | rad/S) ");
      label3.setText("Max Accel: (M/S^2 | rad/S^2) ");
      label4.setText("Freedom Min: (Rad | M)");
      label5.setText("Freedom Max: (Rad | M)");
      //label6.setText("Accel: (rad | M)/s2nm");

      jointPowerOutput.setVisible(true);
      //jointEnergyUsage.setVisible(true);
      jointMaxVelocity.setVisible(true);  
      jointMaxAcceleration.setVisible(true);
      jointFreedomMin.setVisible(true);
      jointFreedomMax.setVisible(true);
      //acceleration.setVisible(true);
    }

    if (bComponent instanceof BSensor)
    {
      componentTypeName.setText("Sensor Name:");
      BSensor bSensor = (BSensor) bComponent;
      sensorRange.setText(bSensor.sensorRange+"");
      sensorScope.setText(bSensor.sensorScope+"");
      sensorAccuracy.setText(bSensor.sensorAccuracy+"");

      if ( bSensor.glow )
        glow.setText("T");
      else
        glow.setText("F");

      label1.setText("Range: Metres ");
      label2.setText("Scope: Degrees ");
      label3.setText("Accuracy: % ");
      label4.setText("Glow: (T||F)");
      sensorRange.setVisible(true);
      sensorScope.setVisible(true);
      sensorAccuracy.setVisible(true);
      glow.setVisible(true);
    }

    if (bComponent instanceof BWeapon)
    {
      componentTypeName.setText("Weapon Name:");
      BWeapon bWeapon = (BWeapon) bComponent;
      strikingMass.setText(bWeapon.strikingMass+"");
      damageBonus.setText((bWeapon.getDamageBonus() * 100f) +"");

      damageResistance.setText(bWeapon.damageResistance+"");
      label1.setText("Strike Mass: Kg ");
      label2.setText("Dmg Bonus: +%");
      label3.setText("Resistance: %");
      strikingMass.setVisible(true);
      damageBonus.setVisible(true);
      damageResistance.setVisible(true);
    }

    if (bComponent instanceof BShielding)
    {
      componentTypeName.setText("Shield Name:");
      BShielding bShielding = (BShielding) bComponent;
      damageResist.setText((int)bShielding.getDamageResist() + "" );
      label1.setText("Damage Resist: % ");
      damageResist.setVisible(true);
    }

    if (component instanceof BChassis)
    {
      componentTypeName.setText("Chassis Name:");

      BChassis bChassis = (BChassis) bComponent;

      //chassisEnergyUsage.setText(bChassis.chassisEnergyUsage + "");
      chassisPowerOutput.setText(bChassis.chassisPowerOutput + "");
      loadCapacity.setText(bChassis.loadCapacity + "");
      chassisMaxVelocity.setText(bChassis.chassisMaxVelocity + "");
      sidewaysMaxVelocity.setText(bChassis.sidewaysMaxVelocity + "");
      backwardsMaxVelocity.setText(bChassis.backwardsMaxVelocity + "");
      rotateSpeed.setText(bChassis.rotateSpeed + "");

      chassisAcceleraion.setText(bChassis.acceleration + "");
      chassisRotateAcceleration.setText(bChassis.rotateAcceleration + "");
      chassisMaxRotateVelocity.setText(bChassis.maxRotateVelocity + "");
      chassisMaxBalancedTorque.setText(bChassis.getMaxBalancedTorque() + "");

      if (bChassis instanceof BHoverChassis)
      {
        chassisHoverHeight.setText(  ((BHoverChassis)bChassis).getHeightInWorldUnits() + "" );
        chassisHoverHeight.setVisible(true);
        label11.setText("Hover Height: m");
      }

      //label1.setText("Energy Use: W/Kg/M/Sec ");
      label1.setText("Power Output: KW ");
      label2.setText("Load Capacity: Kg ");
      label3.setText("Max Velocity: M/S ");
      label4.setText("Side Max Velocity: M/S ");
      label5.setText("Back Max Velocity: M/S ");
      label6.setText("Chassis Tilt Speed Rad/s");
      label7.setText("Acceleration M/S^2");
      label8.setText("Rotate Accel: Rad/S^2");
      label9.setText("Rotate Max Velocity: Rad/s");
      label10.setText("Max Balanced Torque: ");


      //chassisEnergyUsage.setVisible(true);
      chassisPowerOutput.setVisible(true);
      loadCapacity.setVisible(true);
      chassisMaxVelocity.setVisible(true);
      sidewaysMaxVelocity.setVisible(true);
      backwardsMaxVelocity.setVisible(true);
      rotateSpeed.setVisible(true);
      chassisAcceleraion.setVisible(true);
      chassisRotateAcceleration.setVisible(true);
      chassisMaxRotateVelocity.setVisible(true);
      chassisMaxBalancedTorque.setVisible(true);

    }

    if (component instanceof BEnergyGenerator)
    {
      componentTypeName.setText("Energy Generator Name");
      BEnergyGenerator bEnergyGenerator = (BEnergyGenerator) component;
      energyCapacity.setText(bEnergyGenerator.energyCapacity+ "");
      energyOutputRate.setText(bEnergyGenerator.energyOutputRate+ "");
      label1.setText("KW");
      label2.setText("KW/Hr");
      energyCapacity.setVisible(true);
      energyOutputRate.setVisible(true);

    }
    if (component instanceof BArenaOrnament)
    {
      if (((BArenaOrnament)component).getEnableLighting() )
        enableLighting.setText("T");
      else
        enableLighting.setText("F");

      enableLighting.setVisible(true);
      label1.setText("Component reflects light (T|F)");

    }

    setRatios();

  }


  private void setInvisible()
  {
    // Sets all fields not associated with the component superclass to
    // invisible.

    wheelRadius.setVisible(false);

    //cpuMemory.setVisible(false);
    cpuCyclesPerSecond.setVisible(false);

    sensorRange.setVisible(false);
    sensorScope.setVisible(false);
    sensorAccuracy.setVisible(false);
    glow.setVisible(false);

    strikingMass.setVisible(false);
    damageBonus.setVisible(false);
    damageResistance.setVisible(false);

    damageResist.setVisible(false);

    jointMaxVelocity.setVisible(false);
    jointMaxAcceleration.setVisible(false);
    jointPowerOutput.setVisible(false);
    //jointEnergyUsage.setVisible(false);
    jointFreedomMin.setVisible(false);
    jointFreedomMax.setVisible(false);
    //acceleration.setVisible(false);

    //chassisEnergyUsage.setVisible(false);
    chassisPowerOutput.setVisible(false);
    loadCapacity.setVisible(false);
    chassisMaxVelocity.setVisible(false);
    sidewaysMaxVelocity.setVisible(false);
    backwardsMaxVelocity.setVisible(false);
    rotateSpeed.setVisible(false);
    chassisAcceleraion.setVisible(false);
    chassisRotateAcceleration.setVisible(false);
    chassisMaxRotateVelocity.setVisible(false);
    chassisMaxBalancedTorque.setVisible(false);
    chassisHoverHeight.setVisible(false);


    energyCapacity.setVisible(false);
    energyOutputRate.setVisible(false);

    enableLighting.setVisible(false);


    label1.setText("");
    label2.setText("");
    label3.setText("");
    label4.setText("");
    label5.setText("");
    label6.setText("");
    label7.setText("");
    label8.setText("");
    label9.setText("");
    label10.setText("");
    label11.setText("");

    //ratio1.setText("");
    ratio2.setText("");
    ratio3.setText("");
    ratio4.setText("");
    ratio5.setText("");
    //ratio6.setText("");
    //ratio7.setText("");
    //ratio8.setText("");
    //ratio9.setText("");
    //ratio10.setText("");
    //ratio11.setText("");
    ratio12.setText("");
    ratio13.setText("");
    ratio14.setText("");
    ratio15.setText("");
    ratio16.setText("");
    ratio17.setText("");
    ratio18.setText("");
    ratio19.setText("");
    ratio20.setText("");
    ratio21.setText("");
    ratio22.setText("");
    ratio23.setText("");

  }

  public void setWeaponWeight(float weight)
  {
    // Called when Guess Weight is activated for a Weapon
    BDebug.print("Setting Strike Mass to "+(int)weight);
    strikingMass.setText(""+(int)weight);
    //ratio12.setText(""+(int)weight);
  }

  public void setWheelRadius( String radius)
  {
    wheelRadius.setText(  radius );
  }

  public void setRatios()
  {


    ratioCount = 0;
    recPrice = stdComponent.price;
    polyPrice = 0f;

    float thisWeightMin = 10f;
    float thisWeightMax = 150f;
    float thisWeightFactor = 0.8f;
    float thisDamageMin = 500f;
    float thisDamageMax = 1500f;
    float thisDamageFactor = 1.5f;

    if (component instanceof BWheel)
    {
      // do nothing for now
    }
    else if (component instanceof BCpu)
    {
      //calcRatio(ratio13,cpuMemory,((BCpu)stdComponent).getMemoryTime(),false,1f,3f,1f);
      calcRatio(ratio14,cpuCyclesPerSecond,((BCpu)stdComponent).cpuCyclesPerSecond,false,10f,100f,0.5f);
     // calcRatio(ratio15,cpuCapacity,((BCpu)stdComponent).cpuCapacity,false,10f,100f,0.5f);
      thisDamageFactor = 0.3f;
      thisWeightFactor = 0.1f;
      thisWeightMin = 3f;
      thisWeightMax = 30f;
    } else if (component instanceof BAutoRotateJoint) {
      //energyUsage.setText(""+Float.parseFloat(jointPowerOutput.getText())/100f);
      //jointEnergyUsage.setText(""+Float.parseFloat(jointPowerOutput.getText())/10f);
      //acceleration.setText(""+Float.parseFloat(jointPowerOutput.getText())*30f);    // twiddle factor
      calcRatio(ratio14,jointPowerOutput,((BRotateJoint)stdComponent).jointPowerOutput,false,10f,500f,1f);
      //calcRatio(ratio14,jointEnergyUsage,((BRotateJoint)stdComponent).jointEnergyUsage,true,0f,0f,0f);
      calcRatio(ratio15,jointMaxVelocity,((BRotateJoint)stdComponent).getMaxVelocity(),false,0.5f,3f,1f);
      calcRatio(ratio16,jointMaxAcceleration,((BRotateJoint)stdComponent).getMaxAcceleration(),false,0.5f,3f,1f);
      calcRatio(ratio17,jointFreedomMin,((BRotateJoint)stdComponent).getFreedomMin(),false,0f,0f,0f);
      calcRatio(ratio18,jointFreedomMax,((BRotateJoint)stdComponent).getFreedomMax(),false,0f,0f,0f);
      //calcRatio(ratio18,acceleration,((BRotateJoint)stdComponent).getAcceleration(),false,0f,0f,0f);
      thisDamageFactor = 0.5f;
      thisWeightFactor = 0.3f;
      thisWeightMin = 3f;
      thisWeightMax = 30f;
    } else if (component instanceof BRotateJoint) {
      //energyUsage.setText(""+Float.parseFloat(jointPowerOutput.getText())/100f);
      //jointEnergyUsage.setText(""+Float.parseFloat(jointPowerOutput.getText())/10f);
      //acceleration.setText(""+Float.parseFloat(jointPowerOutput.getText())*30f);   // twiddle factor
      calcRatio(ratio14,jointPowerOutput,((BRotateJoint)stdComponent).jointPowerOutput,false,10f,500f,1f);
      //calcRatio(ratio14,jointEnergyUsage,((BRotateJoint)stdComponent).jointEnergyUsage,true,0f,0f,0f);
      calcRatio(ratio15,jointMaxVelocity,((BRotateJoint)stdComponent).getMaxVelocity(),false,0.5f,3f,1f);
      calcRatio(ratio16,jointMaxAcceleration,((BRotateJoint)stdComponent).getMaxAcceleration(),false,0.5f,3f,1f);
      calcRatio(ratio17,jointFreedomMin,((BRotateJoint)stdComponent).getFreedomMin(),false,0f,0f,0f);
      calcRatio(ratio18,jointFreedomMax,((BRotateJoint)stdComponent).getFreedomMax(),false,0f,0f,0f);
      //calcRatio(ratio18,acceleration,((BRotateJoint)stdComponent).getAcceleration(),false,0f,0f,0f);
      thisDamageFactor = 0.5f;
      thisWeightFactor = 0.3f;
      thisWeightMin = 3f;
      thisWeightMax = 30f;
    } else if (component instanceof BTelescopicJoint) {
      //energyUsage.setText(""+Float.parseFloat(jointPowerOutput.getText())/100f);
      //ointEnergyUsage.setText(""+Float.parseFloat(jointPowerOutput.getText())/10f);
      //acceleration.setText(""+Float.parseFloat(jointPowerOutput.getText())*30f);  // twiddle factor
      calcRatio(ratio14,jointPowerOutput,((BTelescopicJoint)stdComponent).jointPowerOutput,false,10f,500f,1f);
      //calcRatio(ratio14,jointEnergyUsage,((BTelescopicJoint)stdComponent).jointEnergyUsage,true,0f,0f,0f);
      calcRatio(ratio15,jointMaxVelocity,((BTelescopicJoint)stdComponent).getMaxVelocity(),false,0.5f,3f,1f);
      calcRatio(ratio16,jointMaxAcceleration,((BTelescopicJoint)stdComponent).getMaxAcceleration(),false,0.5f,3f,1f);
      calcRatio(ratio17,jointFreedomMin,((BTelescopicJoint)stdComponent).getFreedomMin(),false,0f,0f,0f);
      calcRatio(ratio18,jointFreedomMax,((BTelescopicJoint)stdComponent).getFreedomMax(),false,0f,0f,0f);
      //calcRatio(ratio18,acceleration,((BTelescopicJoint)stdComponent).getAcceleration(),false,0f,0f,0f);
      thisDamageFactor = 0.7f;
      thisWeightFactor = 0.3f;
    } else if (component instanceof BSensor) {
      calcRatio(ratio14,sensorRange,((BSensor)stdComponent).sensorRange,false,10f,100f,1.0f);
      calcRatio(ratio15,sensorScope,((BSensor)stdComponent).sensorScope,false,20f,180f,0.7f);
      calcRatio(ratio16,sensorAccuracy,((BSensor)stdComponent).sensorAccuracy,false,10f,100f,1.0f);
      thisDamageFactor = 0.2f;
      thisWeightFactor = 0.1f;
      thisWeightMin = 1f;
      thisWeightMax = 5f;
    } else if (component instanceof BWeapon) {
      float strikingMassValue = Float.parseFloat(strikingMass.getText());
      float weightValue = Float.parseFloat(weight.getText());
      calcRatio(ratio14,new JTextField((int)(strikingMassValue - weightValue)+""),((BWeapon)stdComponent).strikingMass - stdComponent.weight,false,0f,100f,1f);
      //calcRatio(ratio13,damageDealPiercing,((BWeapon)stdComponent).damageDealPiercing,false,0f,0f,0f);
      //calcRatio(ratio14,damageDealCrushing,((BWeapon)stdComponent).damageDealCrushing,false,0f,0f,0f);
      //calcRatio(ratio15,damageDealEnergy,((BWeapon)stdComponent).damageDealEnergy,false,0f,0f,0f);
      calcRatio(ratio15,damageBonus,((BWeapon)stdComponent).getDamageBonus()*100f,false,10f,90f,1.0f);
      calcRatio(ratio16,damageResistance,((BWeapon)stdComponent).damageResistance,false,0f,100f,2f);
      thisDamageFactor = 1.5f;
      thisWeightFactor = 0.5f;
    } else if (component instanceof BShielding) {
      calcRatio(ratio14,damageResist,((BShielding)stdComponent).getDamageResist(),false,0f,100f,2f);
      //calcRatio(ratio13,damageResistPiercing,((BShielding)stdComponent).damageResistPiercing,false,0f,0f,0f);
      //calcRatio(ratio14,damageResistCrushing,((BShielding)stdComponent).damageResistCrushing,false,0f,0f,0f);
      //calcRatio(ratio15,damageResistEnergy,((BShielding)stdComponent).damageResistEnergy,false,0f,0f,0f);
      thisDamageFactor = 1.5f;
      thisWeightFactor = 0.7f;
    } else if (component instanceof BChassis) {
      //calcRatio(ratio13,chassisEnergyUsage,((BChassis)stdComponent).chassisEnergyUsage,true,10f,100f,1f);
      calcRatio(ratio14,chassisPowerOutput,((BChassis)stdComponent).chassisPowerOutput,true,500f,1000f,0.1f);
      calcRatio(ratio15,loadCapacity,((BChassis)stdComponent).loadCapacity,false,1000f,30000f,0.5f);
      calcRatio(ratio16,chassisMaxVelocity,((BChassis)stdComponent).chassisMaxVelocity,false,1f,5f,0.4f);
      calcRatio(ratio17,sidewaysMaxVelocity,((BChassis)stdComponent).sidewaysMaxVelocity,false,1f,5f,0.2f);
      calcRatio(ratio18,backwardsMaxVelocity,((BChassis)stdComponent).backwardsMaxVelocity,false,1f,5f,0.2f);
      calcRatio(ratio19,rotateSpeed,((BChassis)stdComponent).rotateSpeed,false,1f,5f,0.2f);
      calcRatio(ratio20,chassisAcceleraion,((BChassis)stdComponent).acceleration,false,1f,3f,0.4f);
      calcRatio(ratio21,chassisRotateAcceleration,((BChassis)stdComponent).rotateAcceleration,false,1f,3f,0.2f);
      calcRatio(ratio22,chassisMaxRotateVelocity,((BChassis)stdComponent).maxRotateVelocity,false,1f,3f,0.2f);
      calcRatio(ratio23,chassisMaxBalancedTorque,((BChassis)stdComponent).getMaxBalancedTorque(),false,10000f,20000f,0.4f);
      thisWeightMin = 100f;
      thisWeightMax = 500f;
      thisWeightFactor = 0.01f;
      thisDamageMin = 10000f;
      thisDamageMax = 20000f;
      thisDamageFactor = 1.5f;
    } else if (component instanceof BEnergyGenerator) {
      calcRatio(ratio14,energyCapacity,((BEnergyGenerator)stdComponent).energyCapacity,false,500f,1500f,0.4f);
      calcRatio(ratio15,energyOutputRate,((BEnergyGenerator)stdComponent).energyOutputRate,false,5000f,20000f,0.4f);
      thisDamageFactor = 0.3f;
      thisWeightFactor = 0.1f;
    }

    //BDebug.print ("After casts ");

    ratio3.setText("("+stdComponent.price+")");
    calcRatio(ratio4,weight,stdComponent.weight,true,thisWeightMin,thisWeightMax,thisWeightFactor); // Should adjust min/max by sub-class
    calcRatio(ratio5,damageMax,stdComponent.damageMax,false,thisDamageMin,thisDamageMax,thisDamageFactor); // ditto
    //calcRatio(ratio6,damageDealStriking,stdComponent.damageDealStriking,false,0f,0f,0f);    // Redundant
    //calcRatio(ratio11,energyUsage,stdComponent.energyUsage,true,0f,0f,0f);    // Redundant
    //calcRatio(ratio12,ambientSound,0f,false,0f,0f,0f); // Ambient Sound - N/A

    //ratioTotal.setText("Total: "+ratioCount);

    polyPrice = ( MIN_COST_POLY_RATIO * polyCount ) - recPrice;
    polyPrice = java.lang.Math.max( 0f, polyPrice );

    polyCnt.setText("Polys: "+polyCount);

    if ( polyPrice > 0f )
    {
      polyCost.setText("Poly Cost: "+(int)polyPrice);
      polyCost.setForeground(Color.red);
    } else {
      polyCost.setText("");
    }

    recPrice += polyPrice;

    ratioTotal.setText("Price: "+(int)recPrice );


  }

  private void calcRatio(JLabel labelIn, JTextField fieldIn, float stdValue, boolean lessIsMore, float min, float max, float factor)
  {
    // factor dictates how much a magnitude of change in a value effects the final ratio against
    // the standard (as a percentage)

    if ( min == 0.0f )
      min = 0.1f;

    float thisValue = Float.parseFloat(fieldIn.getText());

    /*
    if ( thisValue == 0.0f )
      thisValue = min;
    if ( stdValue == 0.0f )
      stdValue = min;


    float ratio1 = 0f;  // Ratio of this members value to the price
    float ratio2 = 0f;  // Same... but for the Standard Component
    if ( lessIsMore )
    {
      if ( thisValue > max || stdValue > max )
        max = java.lang.Math.max(thisValue,stdValue);
      ratio1 = ( max - thisValue ) / Float.parseFloat(price.getText()) * 1000f;
      ratio2 = ( max - stdValue ) / stdComponent.price * 1000f;
    } else {
      ratio1 = thisValue / Float.parseFloat(price.getText()) * 1000f;
      ratio2 = stdValue / stdComponent.price * 1000f;
    }

    float ratio3 = ratio1 / ratio2 * 100f;
    float variance = (ratio3 - 100f) * factor;
    ratio3 = 100f + variance;
    */

    float ratio3 = 0f;
    float variance = 0f;
    if ( factor == 0f )
    {
      labelIn.setText("N/A");
      labelIn.setForeground(Color.black);
    } else {
      if ( lessIsMore )
      {
        if ( stdValue == 0f )
         variance = ((max - thisValue) - (max - stdValue)) / ((max-min)/2f);
       else
          variance = ((max - thisValue) - (max - stdValue)) / stdValue;
      } else {
       if ( stdValue == 0f )
          variance = (thisValue - stdValue) / ((max-min)/2f);
        else
          variance = (thisValue - stdValue) / stdValue;
      }

      ratio3 = variance * factor;
      recPrice += ratio3 * stdComponent.price;


      labelIn.setText((int)(ratio3 * stdComponent.price)+" ("+stdValue+")");
      labelIn.setForeground(Color.white);
    }

    // 0 means they are even...
    if ( ratio3 < -0.3f )
    {
      labelIn.setForeground(Color.blue);
    } else if ( ratio3 <= -0.01f ) {
      labelIn.setForeground(Color.green);
    } else if ( ratio3 > 0.3f ) {
      labelIn.setForeground(Color.red);
    } else if ( ratio3 >= 0.01f ) {
      labelIn.setForeground(Color.orange);
    }

    ratioCount += (int)variance;

  }

  public void setPrice()
  {
    // Round Price Up to nearest 10 and set price field
    int roundedPrice = (int)(recPrice / 10);
    roundedPrice = roundedPrice * 10;
    if ( roundedPrice < (int)recPrice )
      roundedPrice += 10;
    price.setText(roundedPrice+"");
  }

}

///:~
