package roboforge;

//import java.awt.*;
import javax.swing.*;
//import java.util.*;
//import java.awt.event.*;
//import java.io.*;
//import javax.swing.tree.*;
//import java.beans.*;
//import javax.swing.event.*;
//import javax.swing.border.*;
//import java.net.*;
//import roboforge.net.*;

public class BCreditCardPanel extends JPanel
{

	/**
	 * 
	 */
	private static final long serialVersionUID = -1L;
/*
  JPanel parentPanel;
  int pWidth;
  int pHeight;
  Border panelBorder;

  BButton jBSubmit = new BButton();
  BButton jBCancel = new BButton();
  JLabel jLCardType = new JLabel();
  JLabel jLCardNumber = new JLabel();
  JLabel jLExp = new JLabel();
  JLabel jLCardName = new JLabel();
  JTextField jTCardNumber = new JTextField();
  JTextField jTExp = new JTextField();
  JTextField jTCardName = new JTextField();
  JComboBox jCCardType = new JComboBox(new String[] {"VISA","MASTERCARD","AMEX"});
  boolean cardCreated = false;
  JPanel callingPanel;
  STransferDetail transferDetail;

/*

* Description:
  Allows the user to enter a new credit card

* Example:
* Modification History ( Name, Date, Notes )
  Created HSC, 5 December 1999.



  public BCreditCardPanel(JPanel pPanel,int WIDTH,int HEIGHT)
  {
    try
    {
      pWidth = WIDTH;
      pHeight = HEIGHT;
      parentPanel = pPanel;
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }


  public void setVisible (boolean visible, JPanel callingPanelIn, STransferDetail transferDetailIn)
  {
    callingPanel = callingPanelIn;
    transferDetail = transferDetailIn;
    super.setVisible(visible);
  }

  private void jbInit() throws Exception
  {

    this.setLayout(null);
    //this.setSize(pWidth,pHeight);
    this.setSize(new Dimension(569, 506));

    this.setLayout(null);
    panelBorder = BorderFactory.createEtchedBorder();
    this.setBorder(panelBorder);

    jBCancel.setToolTipText("");
    jBCancel.setText("Cancel");
    jBCancel.setBounds(new Rectangle(330, 299, 100, 25));
    jBCancel.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        jBCancel_actionPerformed(e);
      }
    });
    jLCardType.setText("Card Type");
    jLCardType.setBounds(new Rectangle(159, 153, 104, 21));
    jLCardNumber.setText("Card Number");
    jLCardNumber.setBounds(new Rectangle(159, 184, 88, 21));
    jLExp.setText("Expiry Date");
    jLExp.setBounds(new Rectangle(159, 215, 72, 21));
    jLCardName.setText("Name on Card");
    jLCardName.setBounds(new Rectangle(159, 246, 89, 21));
    jTCardNumber.setBounds(new Rectangle(249, 181, 187, 20));
    jTExp.setBounds(new Rectangle(249, 213, 187, 20));
    jTCardName.setBounds(new Rectangle(249, 244, 187, 20));
    jCCardType.setBounds(new Rectangle(249, 155, 107, 20));
    jBSubmit.setText("Submit");
    jBSubmit.setBounds(new Rectangle(184, 300, 100, 25));
    jBSubmit.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        jBSubmit_actionPerformed(e);
      }
    });
    this.add(jTExp, null);
    this.add(jTCardNumber, null);
    this.add(jLCardType, null);
    this.add(jLCardNumber, null);
    this.add(jLExp, null);
    this.add(jLCardName, null);
    this.add(jCCardType, null);
    this.add(jTCardName, null);
    this.add(jBCancel, null);
    this.add(jBSubmit, null);

  }

  void jBCancel_actionPerformed(ActionEvent e)
  {
    this.setVisible(false);
    callingPanel.setVisible(true);
  }

  void jBSubmit_actionPerformed(ActionEvent e)
  {
     //roboforge.internal.BApplicationFrame bAFrame = (roboforge.internal.BApplicationFrame)this.getParent().getParent();
     SResponseWrapper responseWrapper = null;

   try
   {
    // First check that something has been entered
    if (jTCardName.getText().equals("") || jTCardNumber.getText().equals("") || ((String)jCCardType.getSelectedItem()).equals("") || jTExp.getText().equals(""))
      ;//bAFrame.statusText.setText("All fields must be filled.");
    else
    {
       // Verify the credit card number
       SVerifyCC.verifyCCNumber(jTCardNumber.getText());

       // **** NEED TO VERIFY THE EXP DATE AS WELL ******


       // Put the Credit Card details into the SCCDetail object
       SCCDetail ccDetail = new SCCDetail((String)jCCardType.getSelectedItem(),jTCardName.getText(),jTCardNumber.getText(),jTExp.getText());

       //BRequestDescriptor reqDesc = new BRequestDescriptor("ACC",((BFightPanel)parentPanel).loginId,((BFightPanel)parentPanel).password,((BFightPanel)parentPanel).clientPubKey,BGlobal.URLSGATEWAY);
       BRequestDescriptor reqDesc;

       responseWrapper = SServerAccess.getServerResponse(reqDesc,ccDetail);


       if (responseWrapper.getResponseType().equals("ACC"))
       {
        // Card Creation Successful
       // bAFrame.statusText.setText("Card Successfully Added");
        cardCreated = true;

        // Return focus to the calling Object
        if (callingPanel instanceof BAccountPanel)
        {
          ((BAccountPanel)callingPanel).creditCardSetupDone(cardCreated);
          this.setVisible(false);
        }
        else
        if (callingPanel instanceof BPaymentPanel)
        {
        // If the card has been changed then update the transferDetails
          if (cardCreated)
          {
            try
            {
              // Create the request Wrapper
              //reqDesc = new BRequestDescriptor("CPT","Login ID"((BFightPanel)parentPanel).password,((BFightPanel)parentPanel).clientPubKey,BGlobal.URLSGATEWAY);
              responseWrapper = SServerAccess.getServerResponse(reqDesc,transferDetail);

              // Ok so we got the response back lets see what it is
              if (responseWrapper.getResponseType().equals("CPT"))
              {
                // Everything went ok
                transferDetail = (STransferDetail)responseWrapper.getResponseObject();
                //((BFightPanel)parentPanel).payment.setCallingPanel(this);
                //((BFightPanel)parentPanel).payment.setTransferDetails(transferDetail);
                (//(BFightPanel)parentPanel).payment.setVisible(true);
                this.setVisible(false);
              }
              else if (responseWrapper.getResponseType().equals("ERR"))
              {
                //bAFrame.statusText.setText("Error: " + (String)responseWrapper.getResponseObject());
              }
              else
              {
                //bAFrame.statusText.setText("Error: Unknown Response Type" + (String)responseWrapper.getResponseObject());
              }

            }
            catch (Exception ex)
            {
              BDebug.print(ex.getMessage());
             // bAFrame.statusText.setText("Internal Error: Transfer Detail not Updated");
            }
          }

          ((BPaymentPanel)callingPanel).creditCardSetupDone(cardCreated);
          this.setVisible(false);
          callingPanel.setVisible(true);
        }
        else
        {
          this.setVisible(false);
          callingPanel.setVisible(true);
        }

       }
       else // Card Isn't added
       {
        cardCreated = true;
       // bAFrame.statusText.setText("Card NOT Added: " + (String)responseWrapper.getResponseObject());
       }
    }
   }
   catch (CCException cce)
   {
    BDebug.print(cce.getMessage());
   // bAFrame.statusText.setText(cce.getMessage());
    cardCreated = false;
   }
  
   catch (Exception ex)
   {
    BDebug.print(ex.getMessage());
    //bAFrame.statusText.setText("Card Creation Failed: "+ ex.getMessage());
    cardCreated = false;
   }

  }   */

}
