package roboforge;

import javax.swing.filechooser.*;
import java.io.File;

public class BFileFilter extends FileFilter implements java.io.FileFilter
{
  String[] extension;
  String description;
  boolean returnDirectories;


  public BFileFilter(String[] suffix, String desc,boolean returnDirectories)
  {
    extension = suffix;
    //description = description;
    this.returnDirectories = returnDirectories;
  }

  public String getDescription()
  {
    return description;
  }

  public boolean accept(File f)
  {
    // We may return directories.
    if (f.isDirectory())
    {
      if (returnDirectories)
        return true;
      else
        return false;
    }

    // So, it's a file, check it's extension.
    String name = f.getName().toLowerCase();

    for (int i = 0; i < extension.length;i ++)
    {
      if (name.endsWith(extension[i]))
      {
        return true;
      }
    }

    return false;
  }
}
