package roboforge;

//import java.util.*;
import javax.media.j3d.*;

import roboforge.advertising.*;


public class BPlaceHolder extends BArenaOrnament implements BArenaObject
{
  /*
  * Description:
  Acts as a place holder in the Arena for objects
  It should be constructed using one of it's own static
  members as a construction parameter for itself

  * References:
  *
  * Modification History ( Name, Date, Notes ):
                            HSC 21-May-1999
*/

  static final long serialVersionUID = -1L;

  public static final String TYPE_BOT = "BOT";
  public static final String TYPE_ORNAMENT = "ORNAMENT";
  public static final String TYPE_CAMERA = "CAMERA";
  private String type;

  private String advertID;
  private BAdvert advert;

  public BPlaceHolder(String newName, String filename,String typeIn)
  {
    super(newName, filename);
    type = typeIn;
  }

  public String getType()
  {
    return type;
  }

  public void setType(String typeIn)
  {
    type = typeIn;
  }

  // set the arena object advert ID
  public void setAdvertID(String advertID)
  {  this.advertID = advertID;  }

  // get the arena object advert ID
  public String getAdvertID()
  {  return advertID;  }

  // set the arena object advert
  public void setAdvert(BAdvert advert)
  {  this.advert = advert;  }


  public void init()
 {
  // DO NOTHING, ONLY LOAD Objects When getStructure3D is Called
 }


  public BranchGroup getStructure3D(boolean addZones, boolean addSensors)
 {
  super.init(false);
  return super.getStructure3D();

 }


    // Implementing the BArenaObject




}