package roboforge;

import java.util.*;

public class BShielding extends BComponent
{


  static final long serialVersionUID = 4084271206120420113L;



  public static String COMPONENT_TYPE = "Shield";

  public String getComponentType()
  { return COMPONENT_TYPE; }


  private int damageResistBonus;


  public BShielding(String newName, String filename)
  {
    super( newName,  filename);


  }

  public float getDamageResist()
  { return (float)damageResistBonus; }

  public void setDamageResist(int resist)
  { this.damageResistBonus = resist; }


    public Vector getAttributeStrings()
 // returns a Vector of tuples  (heading, value )
 // 2-d Vector
 {

  Vector theList = super.getAttributeStrings();


  Vector tempV;

  tempV = new Vector(2);
  tempV.add("resistance ");
  tempV.add(damageResistBonus+ "%");
  tempV.trimToSize();
  theList.add(tempV);

  return theList;


  }


  public void upgrade()
 {
   BShielding upgradeTwin =   (BShielding)BComponent.loadFromFile( BGlobal.COMPONENTPATH+getComponentFilePath(), false );

   super.upgrade(upgradeTwin);
   damageResistBonus= upgradeTwin.damageResistBonus;




 }

 //public static final int DAM_THRESHOLD = 20;
 //private static final float BALANCER = 0.5f;
 // DJG July 2001 - Young Ly SUCKS SHIT! What the fuck was this "BALANCER" here for? Dickhead.
 // Caused no end of grief with the players wondering why a weapon took more damage than a shield
 // and also completely undermined our balancing tools. This is the worst case of sabotage-style programming
 // I have ever seen. What a total wanker.

 public float resistDamage(float dam )
  {
    float resist =  ((float)(100 - damageResistBonus ))   /  100f  ;
    float resistedDam = dam * resist;

    if (resistedDam < DAM_THRESHOLD)
      resistedDam = 0;

    //BDebug.print("BShield: BaseDam="+dam+" resist="+resist+" health="+getHealthCurrent()+" resistDam="+resistedDam);

    // HALF DAM
    //resistedDam  = resistedDam * BALANCER;

    // DJG July 2001
    // Change in philosophy to avoid confusion
    if ( resistedDam >= getHealthCurrent() )
      return getHealthCurrent();
    else
      return resistedDam;


  }

 



}