package roboforge.ai.decisions;

import java.util.Enumeration;

public abstract class BLeafNode extends BDecisionTreeNode
  // A terminal node in the decision tree.
  // That is, a node that allows no children.
{

  // Constructor.
  // -------------------------------------------------------------

  public BLeafNode()
  {
    super();
    setAllowsChildren(false);
  }

  public BLeafNode(BLeafNode node)
  {
    super(node);
    setAllowsChildren(false);
  }



  // Accessor methods...
  // -------------------------------------------------------------

  public Enumeration visitableChildren()
    { return EMPTY_ENUMERATION; }

}
