package roboforge.ai.worldstate;

import roboforge.*;
import roboforge.ai.values.*;

public class BBotNumberWorldItem extends BBotWorldItem
{
  BNumber theNumber;

  public BBotNumberWorldItem(String key, String name ,BNumber defaultValue,BNumber lower, BNumber upper ,String units, String description, BBot myBot)
  {
    super( key,  name,  defaultValue,  lower,  upper,  units,description,  myBot);
    theNumber = defaultValue;
  }

  public void setValue (double v)
  {
    theNumber.setValue(v);
  }

  public double getValueDouble()
  {
    return theNumber.getValue();
  }

} 