package roboforge.net.data;

import roboforge.util.data.*;
import roboforge.*;
import java.util.*;

public class BBotValidationData extends BAbstractAtom
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Constructor...
  // -------------------------------------------------------------

  public BBotValidationData(long id)
    { super(id); }


  // Type definition...
  // -------------------------------------------------------------

  public int getType()
    { return BDataTypes.BOT_TO_VALIDATE; }


  // Status codes...
  // -------------------------------------------------------------


  // Data fields...
  // -------------------------------------------------------------
  public byte[] botBytes;
  public Vector uniqueItems;
  public boolean isValid = false;
  public String validationErrors;
  public float tournamentPriceCap;

  
  // Accessor methods...
  // -------------------------------------------------------------

  public byte[] getBotBytes() throws Exception
  {
    try
    {
      return SServerAccess.gzipInflateArray(botBytes);
    }
    catch (Exception e)
    {
      BDebug.print(e.getMessage());
      throw new Exception (e.getMessage());
    }
  }
}
