package roboforge.net.data;

public class BDataTypes
{

  // Type ID definitions for each network data-type.
  // -----------------------------------------------------------

  public static final int ERROR                     = -1;
  public static final int PATCH_REQUEST             = 0;
  public static final int PATCH                     = 1;
  public static final int IDENT                     = 2;
  public static final int ACCOUNT                   = 3;
  public static final int TOURNAMENT                = 4;
  public static final int TOURNAMENT_SUBMIT         = 5;
  public static final int TOURNAMENT_ENTRY          = 6;
  public static final int FIGHT                     = 7;
  public static final int FIGHT_RECORD              = 8;
  public static final int MESSAGE                   = 9;
  public static final int TOURNAMENT_IMAGE          = 10;
  public static final int FIGHT_TO_RUN              = 11;
  public static final int BOT_TO_VALIDATE           = 12;
  public static final int FIGHT_RESULT              = 13;
  public static final int WAIT                      = 14;
  public static final int PROGRESS                  = 15;
  public static final int SOFTURL                   = 16;
  public static final int TIME                      = 17;
  public static final int LOGIN                     = 18;
  public static final int FEATURED_FIGHT            = 19;
  public static final int FEATURED_FIGHT_TYPE       = 20;
  public static final int FEATURED_FIGHT_INFO       = 21;
  public static final int FEATURED_FIGHT_UPDATE     = 22;
  public static final int CR_WRAPPER                = 23;
  // Challenge Room wrapper data
  public static final int CHALLENGE_ROOM            = 24;
  public static final int CR_CONSTANTS              = 25;
  public static final int CR_AUTHENTICATION         = 26;
  public static final int CR_MEMBER                 = 27;
  public static final int CR_ENTER_ROOM             = 28;
  public static final int CR_EXIT_ROOM              = 29;
  public static final int CR_TEST_ALIVE             = 30;
  public static final int CR_CREATE_CHALLENGE       = 31;
  public static final int CR_ACKNOWLEDGE_CHALLENGE  = 32;
  public static final int CR_START_FIGHT            = 33;
  public static final int CR_TOURNAMENT             = 34;
  public static final int CR_TOURNAMENT_UPDATE      = 35;
  public static final int CR_AFK                    = 36;
  public static final int CR_ACCEPT_CHALLENGE       = 37;
  public static final int ADVERT                    = 38;
  public static final int ACCOUNT_RANKING           = 39;
  public static final int ALL_RANKINGS              = 40;
  public static final int CREATE_ACTIVE_ACCOUNT     = 41;
  public static final int BALANCE                   = 42;
  public static final int FP_TRANS_AMT              = 43;
  public static final int ACCOUNT_TRANS             = 44;
  public static final int DEMO_REG                  = 45;
  public static final int DEMO_PATCH                = 46;
}
