package roboforge.net.data;


import roboforge.util.data.*;

public class BFeaturedFightTypeData extends BAbstractAtom
{

  /*
    Holds a row of the the FEATURED_FIGHT
    table.

  */


  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Constructor...
  // -------------------------------------------------------------


  public BFeaturedFightTypeData(long id)
  {super(id);}



  // Type definition...
  // -------------------------------------------------------------

  public int getType()
    { return BDataTypes.FEATURED_FIGHT_TYPE; }

  // Status codes...
  // -------------------------------------------------------------

  public static final int UNKNOWN_TYPE    = -1;
  public static final int UNASSIGNED      = 0;
  public static final int FEATURED        = 1;
  public static final int ALL_TIME_GREAT  = 2;


  // Data fields...
  // -------------------------------------------------------------
  public String typeName;

}
