package roboforge.net.data;

import roboforge.util.data.*;


public class BFightResultData extends BAbstractAtom
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Constructor...
  // -------------------------------------------------------------

  public BFightResultData(long id)
    { super(id); }


  // Type definition...
  // -------------------------------------------------------------

  public int getType()
    { return BDataTypes.FIGHT_RESULT; }


  // Status codes...
  // -------------------------------------------------------------

  // Data fields...
  // -------------------------------------------------------------

  public byte[] battleRecordingBytes;
  public byte[] bot1StatsBytes;
  public byte[] bot2StatsBytes;
  public long winner = 0;
  public long tournamentEntryID1;
  public long tournamentEntryID2;
  public String winDescription;
  // The description of how the fight was won
  
  // Accessor methods...
  // -------------------------------------------------------------

}
