package roboforge.net.data;

import roboforge.util.data.*;


public class BPatchRequestData extends BAbstractAtom
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Constructor...
  // -------------------------------------------------------------

  public BPatchRequestData(long id)
    { super(id); }

  public BPatchRequestData(float version)
  { 
    super(0); 
    this.versionID = version;
  }
  

  // Type definition...
  // -------------------------------------------------------------

  public int getType()
    { return BDataTypes.PATCH_REQUEST; }


  // Data fields...
  // -------------------------------------------------------------

  public float versionID;

  // language?

}
