package roboforge.ui.console;

import javax.media.j3d.*;
import javax.vecmath.*;



public class BConsoleGeometry extends BConsoleComponent
{

  protected int offset_x;
  protected int offset_y;

  public BConsoleGeometry()
    { super(); }


  public void setGeometry(Node n)
  {
    if (locTransformGroup.numChildren() != 0)
      locTransformGroup.removeChild(0);

    // Must be called BEFORE component is made live.
    locTransformGroup.addChild(n);
  }

  protected void setOffset(int x, int y)
  {
    this.offset_x = x;
    this.offset_y = y;
    update3DLocation();
  }


  protected void setLocationVector(Vector3d v)
    { v.set(x - offset_x, -y + offset_y, z); }

  protected void transformChildLocationVector(BConsoleComponent child, Vector3d v)
  {
    v.x += offset_x;
    v.y -= offset_y;
  }

}