package roboforge.ui.fusion;

import roboforge.BGlobal;
import roboforge.sound.*;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import javax.swing.AbstractButton;
import javax.swing.JComponent;



public class FusionActionSound implements ActionListener
{
  protected final BSound sound;

  public FusionActionSound(String sound)
  {
    this.sound = BSound.getSound(
      BGlobal.SOUNDPATH+ "interface/"+ sound);
  }

  public void install(JComponent c)
  { 
    if (c instanceof AbstractButton)
      ((AbstractButton) c).addActionListener(this); 
  }

  public void actionPerformed(ActionEvent e)
  { 
    if (!sound.isRunning())
      sound.play(); 
  }
}

