package roboforge;

import roboforge.BArena;
import roboforge.animation.*;


public abstract class BAnimatedArenaOrnament extends BArenaOrnament
{

  // Serialization ID.
  static final long serialVersionUID = -1L;


  public BAnimatedArenaOrnament(String name, String filename)
    { super(name, filename); }

  public void initArenaDetails(BArena arena)
  {
    super.initArenaDetails(arena);

    // Check for an arena animation...
    BAnimation animation = this.getAnimation();

    // If one exists, add it to the arena.
    if (animation != null)
      arena.addAnimation(animation);
  }

  public abstract BAnimation getAnimation();

} 