package roboforge;

import com.sun.j3d.utils.behaviors.mouse.MouseTranslate;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.media.j3d.*;
import javax.vecmath.*;
//import com.sun.j3d.utils.behaviors.picking.*;


public class BMouseTranslate extends MouseTranslate {

    double x_factor = .2;
    double y_factor = .2;
    Vector3d translation = new Vector3d();


  public BMouseTranslate() {
  }


    public void processStimulus (Enumeration criteria) {
    WakeupCriterion wakeup;
    AWTEvent[] event;
    int id;
    int dx, dy;

    while (criteria.hasMoreElements()) {
      wakeup = (WakeupCriterion) criteria.nextElement();

      if (wakeup instanceof WakeupOnAWTEvent) {
	event = ((WakeupOnAWTEvent)wakeup).getAWTEvent();
	for (int i=0; i<event.length; i++) {
	  processMouseEvent((MouseEvent) event[i]);

	  if (((buttonPress)&&((flags & MANUAL_WAKEUP) == 0)) ||
	      ((wakeUp)&&((flags & MANUAL_WAKEUP) != 0))){
	    id = event[i].getID();
	    if ((id == MouseEvent.MOUSE_DRAGGED) &&
		((MouseEvent)event[i]).isControlDown() &&
		((MouseEvent)event[i]).isMetaDown()){


	      x = ((MouseEvent)event[i]).getX();
	      y = ((MouseEvent)event[i]).getY();

	      dx = x - x_last;
	      dy = y - y_last;

	      if ((!reset) && ((Math.abs(dy) < 50) && (Math.abs(dx) < 50))){
		//System.out.println("dx " + dx + " dy " + dy);
		transformGroup.getTransform(currXform);


		// REMOVE X TRANSLATE


		//translation.x = dx*x_factor;

    //if (  ((MouseEvent)event[i]).isAltDown()  )

      //translation.x = dx*x_factor;

    	translation.y = -dy*y_factor;

		transformX.set(translation);

		if (invert) {
		  currXform.mul(currXform, transformX);
		} else {
		  currXform.mul(transformX, currXform);
		}

		transformGroup.setTransform(currXform);

		transformChanged( currXform );

	      //	if (callback!=null)
	     //	    callback.transformChanged( MouseBehaviorCallback.TRANSLATE,
	     //				       currXform );

	      }
	      else {
		reset = false;
	      }
	      x_last = x;
	      y_last = y;
	    }
	    else if (id == MouseEvent.MOUSE_PRESSED) {
	      x_last = ((MouseEvent)event[i]).getX();
	      y_last = ((MouseEvent)event[i]).getY();
	    }
	  }
	}
      }
    }

    wakeupOn (mouseCriterion);
  }




   public void initialize()
   {
    super.initialize();
    if ((flags & INVERT_INPUT) == INVERT_INPUT)
       {
       invert = true;
       x_factor *= -1;
       y_factor *= -1;
        }

    }













}