package roboforge;

import javax.media.j3d.GraphicsContext3D;



public interface BRenderable
{

  // A BRenderable is an entity that can render its
  // 3D representation to a GraphicsContext3D.
  // Used for immediate-mode rendering of certain
  // systems, e.g. particle systems.


  public void render(GraphicsContext3D g);
    // Render using the supplied graphics context.
} 