package roboforge;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.sql.*;
import java.util.*;

// *** IMPORTANT ***
// If any of the SQL is changed in this class the change must also be implemented in the
// STransferReg Class

public class SAltPmntServlet extends SHttpServletJXGB
{

  String orderTextCheque = "";
  String orderCDTextCheque = "";
  String CD;

  //String urlPrefix = "Z:/Website/Main/";
  //String urlPrefix = "http://www.roboforge.net/";
  String urlPrefix = "https://secure.rftournaments.com/";

  //Initialize global variables
  public void init(ServletConfig config) throws ServletException
  {
    super.init(config);

    try
    {

      BufferedReader br = new BufferedReader
      (new FileReader("D:/RoboForge/orderconfirmCheque.txt"));

      char[] c = new char[1];
      char g = (char)-1;
      while ((c[0] = (char)br.read()) != g)
        orderTextCheque += new String (c); //+ "\n";
      br.close();

      br = new BufferedReader
      (new FileReader("D:/RoboForge/orderconfirmCDCheque.txt"));

      c = new char[1];
      g = (char)-1;
      while ((c[0] = (char)br.read()) != g)
        orderCDTextCheque += new String (c); //+ "\n";
      br.close();


      }
      catch (Exception e)
      {
        System.err.println("SPreOrder:Init: " + e.getMessage());
      }

  }

  //Process the HTTP Get request
  public void doGet(HttpServletRequest request,HttpServletResponse response) throws ServletException, IOException
  {
    doPost(request, response);
  }
  
  //Process the HTTP Post request
  public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
  {
    // Taken out 4/07/00 As now doing redirect again
    //response.setStatus(HttpServletResponse.SC_MOVED_PERMANENTLY);

    Connection con = null;
    String name = "";
    String email = "";

    try
    {
      // Code to track down the null parameter bug
      if (request == null)
      {
        System.err.println("*** Request is NULL");
        response.sendRedirect(urlPrefix + "error.htm");
        return;
      }
      else
      {
        if (request.getParameter("COUNTRY")== null)
        {
          System.err.println("*** COUNTRY is NULL");
          response.sendRedirect(urlPrefix + "saleserr1.htm");
          return;
        }
        else if (request.getParameter("FNAME")== null)
        {
          System.err.println("*** FNAME is NULL");
          response.sendRedirect(urlPrefix + "saleserr1.htm");
          return;
        }
        else if (request.getParameter("LNAME")== null)
        {
          System.err.println("*** LNAME is NULL");
          response.sendRedirect(urlPrefix + "saleserr1.htm");
          return;
        }

        else if (request.getParameter("ADDR1")== null)
        {
          System.err.println("*** ADDR1 is NULL");
          response.sendRedirect(urlPrefix + "saleserr1.htm");
          return;
        }
        /*else if (request.getParameter("ADDR2")== null)
        {
          System.err.println("*** ADDR2 is NULL");
          response.sendRedirect(urlPrefix + "saleserr1.htm");
          return;
        }*/
        else if (request.getParameter("CITY")== null)
        {
          System.err.println("*** CITY is NULL");
          response.sendRedirect(urlPrefix + "saleserr1.htm");
          return;
        }
        else if (request.getParameter("STATE")== null && request.getParameter("COUNTRY") == "United States")
        {

          System.err.println("*** STATE is NULL");
          response.sendRedirect(urlPrefix + "saleserr1.htm");
          return;
        }
        else if (request.getParameter("ZIP")== null)
        {
          System.err.println("*** ZIP is NULL");
          response.sendRedirect(urlPrefix + "saleserr1.htm");
          return;
        }
        else if (request.getParameter("EMAIL")== null)
        {
          System.err.println("*** EMAIL is NULL");
          response.sendRedirect(urlPrefix + "saleserr1.htm");
          return;
        }
        else if (request.getParameter("EMAIL2")== null)
        {
          System.err.println("*** EMAIL is NULL");
          response.sendRedirect(urlPrefix + "saleserr1.htm");
          return;
        }
        else if (request.getParameter("CD")== null)
        {
          //System.err.println("*** CD is NULL");
          CD = "NO";
        }
      }

      boolean submissionOK;

      if ((request.getParameter("STATE").equals("") || request.getParameter("STATE") == null) && request.getParameter("COUNTRY").equals("United States"))
      {
        submissionOK = false;
      }
      else if ((request.getParameter("EMAIL").equals(""))|| (request.getParameter("FNAME").equals(""))
        || (request.getParameter("LNAME").equals("")) )
      {
        // Client wants to register however they haven't entered all the fields required.
        submissionOK = false;
      }
      else
      {
        submissionOK = true;
      }

      if (submissionOK)
      {
        // Check to see if both emails match
        if (request.getParameter("EMAIL").compareToIgnoreCase(request.getParameter("EMAIL2")) != 0)
        {
          System.err.println("*** EMAILS DON'T MATCH");
          response.sendRedirect(urlPrefix + "saleserr5.htm");
          return;
        }

        String EMAIL    = SServerAccess.parseString(request.getParameter("EMAIL"));
        String FNAME    = SServerAccess.parseString(request.getParameter("FNAME"));
        String LNAME    = SServerAccess.parseString(request.getParameter("LNAME"));
        String ADDR1    = SServerAccess.parseString(request.getParameter("ADDR1"));

        String ADDR2;
        if (request.getParameter("ADDR2") != null)
          ADDR2    = SServerAccess.parseString(request.getParameter("ADDR2"));
        else
          ADDR2 = "";

        String CITY     = SServerAccess.parseString(request.getParameter("CITY"));
        String STATE;

        if (request.getParameter("STATE") == null)
            STATE = "";
        else
            STATE = SServerAccess.parseString(request.getParameter("STATE"));

        String ZIP      = SServerAccess.parseString(request.getParameter("ZIP"));
        String COUNTRY  = SServerAccess.parseString(request.getParameter("COUNTRY"));

        if (request.getParameter("CD") != null)
          CD       = SServerAccess.parseString(request.getParameter("CD"));

        // Determine if the email address already exists in the database
        con = getDatabaseConnection();

        // Fixup any quotations from the strings to make them Oracle safe
        name = SServerAccess.parseString(name);
        email = SServerAccess.parseString(email);

        // Test to see if the names are too long and if so truncate them to the max allowed length
        if (EMAIL.length()>50)
          EMAIL = EMAIL.substring(0,50);

        if (FNAME.length()>25)
          FNAME = FNAME.substring(0,25);

        if (LNAME.length()>25)
          LNAME = LNAME.substring(0,25);

        if (ADDR1.length()>50)
          ADDR1 = ADDR1.substring(0,50);

        if (ADDR2.length()>50)
          ADDR2 = ADDR2.substring(0,50);

        if (CITY.length()>25)
          CITY = CITY.substring(0,25);

        if (STATE.length()>25)
          STATE = STATE.substring(0,25);

        if (ZIP.length()>10)
          ZIP = ZIP.substring(0,10);

        if (COUNTRY.length()>50)
          COUNTRY = name.substring(0,50);

        if (CD.length()>3)
          CD = CD.substring(0,3);

        if (con != null)
        {
          // Turn off autocommit so we can rollback in the event of any errors
          con.setAutoCommit(false);


          // No longer check for the status of an account
          /*
          // Check to see if the email address exists for an OPEN account
          Statement statement = con.createStatement();
          String sql = "SELECT id FROM ACCOUNT WHERE LOWER(email) = LOWER('" + EMAIL + "')";
          sql += " AND status = 'OPEN'";
          ResultSet rs = statement.executeQuery(sql);
          if (rs.next())
          {
            // OPEN account already exists so redirect them to
            // error page
            statement.close();
            rs.close();
            response.sendRedirect("http://www.roboforge.net/subexst.htm");
            return;

          }

          statement.close();
          rs.close();
           */

          Statement statement = con.createStatement();
          String sql = "SELECT id FROM ACCOUNT WHERE LOWER(email) = LOWER('" +  EMAIL + "')";

          ResultSet rs = statement.executeQuery(sql);
          name = FNAME.trim() + " " + LNAME.trim();

          if (!rs.next())
          {
            // Account doesn't exist so build Insert Statement
            sql = "INSERT INTO ACCOUNT (email,first_name,last_name,name,address1,address2,";
            sql += "city,state,post_code,country,status,registration_key)";
            sql += " VALUES (LOWER('" + EMAIL + "'),'" + FNAME + "','" + LNAME + "','" + name + "','" + ADDR1 + "',";
            sql += " '" + ADDR2 + "','" + CITY + "','" + STATE + "','" + ZIP + "','" + COUNTRY +"','P',getRegKey)";

          }
          else
          {
            // Account already exists so build Update statement
            long accountID     = rs.getLong("id");

            sql = "UPDATE ACCOUNT";
            sql += " SET email = LOWER('" + EMAIL + "'),first_name = '" + FNAME + "',";
            sql += "last_name = '" + LNAME + "',name = '" + name + "',";
            sql += "address1 = '" + ADDR1 + "',address2 = '" + ADDR2 + "',";
            sql += "city = '" + CITY + "',state = '" + STATE + "',";
            sql += "post_code = '" + ZIP + "',country = '" + COUNTRY + "'";
            sql += " WHERE id = " + accountID;
          }
          // Added additional close statements HSC 19/4/2000

          rs.close();
          statement.close();

          statement = con.createStatement();
          statement.executeUpdate(sql);
          statement.close();


          // Get the account ID
          sql = "SELECT id FROM ACCOUNT WHERE LOWER(email) = LOWER('" +  EMAIL + "')";
          statement = con.createStatement();
          rs = statement.executeQuery(sql);

          rs.next();

          long accountID = rs.getLong("id");

          rs.close();
          statement.close();


          // Create the order entry

          String productID = "RF05";
          float price       = 0.0f;


          if (CD.equals("YES"))
          {
            productID = "CD05";
          }

          // Create the product record
          sql = "INSERT INTO PRODUCT_ORDER (account_id,product_id,date_ordered,quantity_ordered,price,currency)";
          sql +=" VALUES (" + accountID + ",'" + productID + "',SYSDATE,1," + price + ",'" + request.getParameter("TOTAL") + "')";


          statement = con.createStatement();
          statement.executeUpdate(sql);
          statement.close();


          // Send the email:

          String emailText;

          // Select the appropriate text
          if (CD.equals("YES"))
            emailText = orderCDTextCheque;
          else
            emailText = orderTextCheque;

          // Place in order Number
          String orderNo = accountID + "/" + productID;

          int loc = emailText.indexOf("[ORDERNO]");

          emailText = emailText.substring(0,loc) + orderNo + emailText.substring(loc+9,emailText.length());
          // Place in the Email
          loc = emailText.indexOf("[EMAIL]");

          emailText = emailText.substring(0,loc) + EMAIL + emailText.substring(loc+7,emailText.length());

          // Place in the Name
          loc = emailText.indexOf("[NAME]");

          emailText = emailText.substring(0,loc) + name + emailText.substring(loc+6,emailText.length());

          // Place in the total
          loc = emailText.indexOf("[TOTAL]");

          emailText = emailText.substring(0,loc) + request.getParameter("TOTAL") + emailText.substring(loc+7,emailText.length());

          if (CD.equals("YES"))
          {
            // Build the address
            String add = ADDR1 + "\n";
            add += ADDR2 + "\n";
            add += CITY + "\n";
            add += STATE + "\n";
            add += ZIP + "\n";
            add += COUNTRY;

            // Place in the address
            loc = emailText.indexOf("[ADDR]");

            emailText = emailText.substring(0,loc) + add + emailText.substring(loc+6,emailText.length());

          }

          // Send the email
          BDebug.print("About to send the email to: " + EMAIL);
          BDebug.print("ORDER Name: " + name);
          BDebug.print("ORDER Addr1: " + ADDR1);
          BDebug.print("ORDER Addr2: " + ADDR2);
          BDebug.print("ORDER City: " + CITY);
          BDebug.print("ORDER State: " + STATE);
          BDebug.print("ORDER Zip: " + ZIP);
          BDebug.print("ORDER Country: " + COUNTRY);
          BDebug.print("ORDER ProductID: " + productID);

          new SMTPBean("mail-int.clearfield.com", 25, "rforge@roboforge.com", EMAIL, "RoboForge Order Confirmation", emailText);
          //new SMTPBean("edge", 25, "admin@roboforge.com", EMAIL, "RoboForge Order Confirmation", emailText);


          BDebug.print("Sent the email to: " + EMAIL);

          BDebug.print("About to send the email to: mike@roboforge.com");
          new SMTPBean("mail-int.clearfield.com", 25, "rforge@roboforge.com", "mike@roboforge.com", "Cheque Order For Mike!", emailText);
          BDebug.print("Sent the email to: mike@roboforge.com");

          con.commit();
          con.setAutoCommit(true);

          response.sendRedirect(urlPrefix + "salesok.htm");

          return;

        }
        else
        {
          // Null connection
          response.sendRedirect(urlPrefix + "error.htm");
          return;

        }
      }
      else
      {
        // %% Use the following method in the future to redirect the browser
        // Need to change this to be the correct website once live ie roboforge etc
        //response.sendRedirect("\\\\EDGE/Edge/Website/Main/suberr.htm");
        //response.sendRedirect(SGlobal.WEB_PAGE_LOCATION +"/suberr.htm");

        response.sendRedirect(urlPrefix + "saleserr1.htm");
        //response.setHeader("Location","/suberr.htm");
        return;
        //response.sendRedirect("http://server.roboforge.com/suberr.htm");

      }
    }
    catch (Exception e)
    {
      System.err.println("Error SAltPmntServlet.doPost: "+ e.getMessage());
      try
      {
        if (con != null)
        {
          con.rollback();
          con.setAutoCommit(true);
        }
      }
      catch (Exception e2)
      {
        System.err.println("Error SAltPmntServlet.doPost.rollback: " + e2.getMessage());
      }

        response.sendRedirect(urlPrefix + "error.htm");
        return;
    }
    finally
    {
      try
      {
        if (con!= null)
        {
          myBroker.freeConnection(con);
        }

      }
      catch(Exception e3)
      {
        System.err.println("Error SAltPmntServlet.myBroker.freeConnection: "+e3.getMessage());
      }
    }


  }
  private Connection getDatabaseConnection()
  {
    Connection con = null;
    try
    {
      con = myBroker.getConnection();  
      /*
      Class.forName ("oracle.jdbc.driver.OracleDriver");
      con = DriverManager.getConnection("jdbc:oracle:thin:@hugh:1521:edge", "edge", "edge");
      */
      //Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
      //con = DriverManager.getConnection("jdbc:odbc:Testy");
    }

    catch (Exception sqle)
    {
      System.err.println("Error SAltPmntServlet.getDatabaseConnection: " + sqle.getMessage());
    }
  return con;
  }
  //Get Servlet information
  public String getServletInfo()
  {
    return "roboforge.SAltPmntServlet Information";
  }
}