package roboforge;

import java.sql.*;
import java.io.*;
import java.util.*;

public class SLoginBean extends SJDBCBean
{

  private String sql;
  private Statement statement;
  private ResultSet rs;

  private String loginID;
  private String password;

  public SLoginBean() throws Exception
  {
    super();
  }

  public void setLogAndPass(String log, String pass)
  {
    loginID   = log;
    password  = pass;
  }

  public boolean isLogInOK ()
  {

    Connection con = null;
    try
    {
      con = this.getConnection();

      sql = "SELECT count(*) AS count FROM ACCOUNT a, ACCOUNT_PERMISSION ap";
      sql += " WHERE ap.account_id = a.id AND";
      sql += " loginid = '" + loginID + "' AND password = '" + password + "'";

      statement = con.createStatement();
      rs = statement.executeQuery(sql);
      rs.next();
      int count = rs.getInt("count");

      rs.close();
      statement.close();

      if (count == 0)
      {
        // Login Failed
        return false;
      }
      else
      {
        // Login OK
        return true;
      }
    }
    catch (Exception e)
    {
      System.err.println("Error: SLoginBean: " + e.getMessage());
    }
    finally
    {
      if (con != null)
        this.freeConnection(con);
    }

    return false;

  }
} 