package roboforge;

import java.io.*;
import java.util.*;
import java.sql.*;
public class SOutput
{
  /*

  * Description:
    Used to output errors to either a text file, a database, or both.
  * Example:
  * Modification History ( Name, Date, Notes ):
    Created HSC, 15-November-1999

  */

  public SOutput()
  {
  }

  public static void errOutputText (String errMessage)
  {
    if (SGlobal.ERROR_OUTPUT_ON)
    {
      // First write to text file
      try
      {
        PrintStream out = new PrintStream( new BufferedOutputStream (new FileOutputStream(SGlobal.ERROR_PATH,true)));
        out.println(errMessage);
        out.close();
      }
      catch (FileNotFoundException fnfe)
      {
        System.err.println("SOutput ERROR: " + fnfe.getMessage());
      }
      catch (IOException ioe)
      {
        System.err.println("SOutput ERROR: " + ioe.getMessage());
      }
    }
  }

  public static void errOutputDatabase (int accountID,String errMessage, Connection con)
  {
    if (SGlobal.ERROR_OUTPUT_ON)
    {
      try
      {
        Statement statement = con.createStatement();
        statement.executeUpdate("INSERT INTO LOG (ACCOUNT_ID,NARRATIVE,DATE_OF_ENTRY) VALUES (" + accountID + " ,'" + errMessage + "', SysDate)");
        statement.close();
      }
      catch (SQLException sqle)
      {
        System.err.println("SOutput ERROR: " + sqle.getMessage());
      }

    }
  }

  public static void main(String[] args)
  {


  }
}