package roboforge;

import java.util.*;
import java.lang.System;

public class STournament
{
  /*  Holds the details of Tournament
   *  in a challenge room
  */

  // Member variables...
  // -------------------------------------------------------------

  Long tournamentID;
  Long challengerID;
  Long challengedID;
  String challengerDesignerName;
  String challengedDesignerName;
  String tournamentStatus;
  float fightProgress;
  long challengerTEID;
  long challengedTEID;
  String challengerBotName = "Waiting for Entry.";
  String challengedBotName = "Waiting for Entry.";

  long timeTournamentCreated;
  String tournamentName;
  long timeLastUpdated;
  // Once a fight is running this records the last time the
  // percentage progress changed.  Used for deleting stalled fights 


  long fightID;

  String tournamentType;




  public STournament(Long tournamentID, Long challengerID,
                      Long challengedID, String tournamentStatus,
                      String challengerDesignerName, String challengedDesignerName,
                      long challengerTEID, String tournamentName, String tournamentType)
  {
    this.tournamentID             = tournamentID;
    this.challengerID             = challengerID;
    this.challengedID             = challengedID;
    this.challengerDesignerName   = challengerDesignerName;
    this.challengedDesignerName   = challengedDesignerName;
    this.tournamentStatus         = tournamentStatus;
    this.challengerTEID           = challengerTEID;
    this.tournamentName           = tournamentName;
    this.tournamentType           = tournamentType;
    timeTournamentCreated         = System.currentTimeMillis();
  }
}
