package roboforge.ai.decisions;

public abstract class BBranchNode extends BDecisionTreeNode
  // Node which allows visits to one [or more?] of
  // its children.
{

  // Constructors...
  // -------------------------------------------------------------

  public BBranchNode()
    { super(); }

  public BBranchNode(BBranchNode node)
    { super(node); }


  // Accessor methods...
  // -------------------------------------------------------------

  public boolean canAddChildren()
    { return getChildCount() < 2; }

  public boolean canRemoveChildren()
    { return true; }


  // Open / close methods...
  // -------------------------------------------------------------

	public boolean isCloseable()
  	{ return true; }


}
