package roboforge.ai.expressions;

import roboforge.ai.values.*;

 
public class BConstants
{

  // Boolean constants...
  // -------------------------------------------------------------

  public static final BConstant TRUE
    = new BConstant(BBoolean.TRUE);

  public static final BConstant FALSE
    = new BConstant(BBoolean.FALSE);


  // Numeric constants...
  // -------------------------------------------------------------

  public static final BNamedConstant PI
    = new BNamedConstant("pi", new BNumber(Math.PI));

}