package roboforge.ai.worldstate;

import roboforge.*;
import roboforge.ai.values.*;

public class BSimNumberWorldItem extends BWorldItem
{
  BSimulation sim;
  BNumber theNumber;

  public BSimNumberWorldItem(String key, String name ,BNumber defaultValue,BNumber lower, BNumber upper ,String units, String description, BSimulation sim)
  {
    super( key,  name,  defaultValue,  lower,  upper,  units, description);
    this.sim = sim;
    this.theNumber = defaultValue;

  }    

  public void setValue (double v)
  { theNumber.setValue(v); }

  public void initForSim(BSimulation sim)
  {
    super.initForSim( sim);
    this.sim = sim;
  }

  public BSimulation getSim()
  { return sim; }

} 