package roboforge.animation;

public abstract class BAbstractAnimation implements BAnimation
{

  protected boolean isAnimating;


  public BAbstractAnimation()
    { setAnimating(false); }


  public void start()
    { setAnimating(true); }

  public void stop()
    { setAnimating(false); }


  protected synchronized void setAnimating(boolean a)
    { this.isAnimating = a; }

  public synchronized boolean isAnimating()
    { return isAnimating; }

}
