package roboforge.animation.time;

public class BWaitAnimation extends BTimeAnimation
{

  // BWaitAnimation simply waits for 'duration' seconds
  // before completing.

  protected float duration;
    // Amount of time to wait, in seconds.

  public BWaitAnimation(float duration)
    { setDuration(duration); }


  public void setDuration(float duration)
    { this.duration = duration; }

  public float getDuration()
    { return duration; }


  public void start(float t)
    { }

  public boolean animate(float t, float dt)
    { return (t <= duration); }

  public void stop(float t)
    { }

} 