package roboforge.net;

import java.io.*;

public class BDescriptor implements Serializable
{
  private String type;
  private long size;
  private boolean encrypted;
  private boolean zipped;

  public BDescriptor(String typeIn)
  {
    this(typeIn,0);
  }
  public BDescriptor(String typeIn, long sizeIn)
  {
    this(typeIn, sizeIn, true, true);
  }
  public BDescriptor(String typeIn, long sizeIn, boolean isEncrypted, boolean isZipped)
  {
    type = typeIn;
    size = sizeIn;
    encrypted = isEncrypted;
    zipped = isZipped;
  }

  public String getType()
  {
    return type;
  }

  public long getSize()
  {
    return size;
  }

  public void setSize(long sizeIn)
  {
    size = sizeIn;
  }

  public boolean isEncrypted()
  {
    return encrypted;
  }

  public boolean isZipped()
  {
    return zipped;
  }

  public void setEncrypted(boolean encrypted)
  {
    this.encrypted = encrypted;
  }

  public void setZipped(boolean zipped)
  {
    this.zipped = zipped;
  }
}