package roboforge.net.data;

import roboforge.util.data.*;


public class BRankingData extends BAbstractAtom
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Constructor...
  // -------------------------------------------------------------

  public BRankingData(long id)
    { super(id); }


  // Type definition...
  // -------------------------------------------------------------

  public int getType()
    { return BDataTypes.ALL_RANKINGS; }


  // Status codes...
  // -------------------------------------------------------------

  public static final int PROFESSIONAL  = 0;
  public static final int AMATEUR       = 1;

  public static final String PRO        = "PR";
  public static final String AM         = "AR";


  // Data fields...
  // -------------------------------------------------------------

  public String designerName;
  public int ranking;
  public float points;

  // Accessor methods...
  // -------------------------------------------------------------

}