package roboforge.particles.forces;

import javax.vecmath.*;
import roboforge.particles.*;

public class BDragForce implements BParticleForce
{

  protected float kd;
    // Coefficient of drag.

  public BDragForce(float kd)
    { this.kd = kd; }

  public void apply(BParticle p, float t, Vector3f f)
    { f.scaleAdd(-kd, p.v, f); }

  public void update(float t)
    { /* Do nothing. */ }
    
}