package roboforge.ui.components;

import java.util.Vector;
import javax.swing.DefaultComboBoxModel;

public class BComboBoxModel
  extends    DefaultComboBoxModel
  implements BMutableListModel
{

  public BComboBoxModel()
    { super(); }

  public BComboBoxModel(Vector v)
    { super(v); }

  public void add(Object o)
    { addElement(o); }

  public void addAt(Object o, int i)
    { insertElementAt(o, i); }

  public Object getAt(int i)
    { return getElementAt(i); }

  public int indexOf(Object o)
    { return getIndexOf(o); }

  public void remove(Object o)
    { removeElement(o); }

  public void removeAt(int i)
    { removeElementAt(i); }

  public boolean isRemoveable(Object o)
    { return true; }

  public boolean isRemoveableAt(int i)
    { return true; }

  public void notifyChange(Object o)
  {
    int i = getIndexOf(o);
    if (i != -1)
      super.fireContentsChanged(this, i, i);
  }

  public void notifyChange()
    { fireContentsChanged(this, -1, -1); }

  public boolean isEmpty()
    { return getSize() == 0; }

  /*
  public void setData(Vector v)
  {
    synchronized(objects)
      { objects = v; }

    fireContentsChanged(0, v.getSize()-1);
  }
  */
}
