package roboforge.ui.components;

import roboforge.ui.components.text.*;



public class BIntField extends BGuardedTextField
{

  // Constructor.
  // -------------------------------------------------------------

  public BIntField(BUIResources res, String key)
  {
    super(res, key);
    setGuard(new BIntGuard());
  }

  public BIntField()
  { 
    super(); 
    setGuard(new BIntGuard());
  }

  public BIntField(int i)
  {
    this();
    setValue(i);
  }


  // Accessor methods...
  // -------------------------------------------------------------

  public int getValue()
  {
    try
      { return Integer.parseInt(getText()); }
    catch (NumberFormatException e)
      { return 0; }
  }

  public void setValue(int i)
    { setText(Integer.toString(i)); }


}
