package roboforge.ui.fusion;

import java.awt.*;
import javax.swing.*;
import javax.swing.plaf.*;

public class FusionSystemButtonUI extends FusionButtonUI
{
  // Shared UI object
  private final static FusionSystemButtonUI buttonUI = new FusionSystemButtonUI();

  public static ComponentUI createUI(JComponent c)
    { return buttonUI; }

  protected void installDefaults(AbstractButton b)
  {
    super.installDefaults(b);
    String pp = "SystemButton.";

    pressedColor   = UIManager.getColor(pp+ "pressedColor");
    disabledColor  = UIManager.getColor(pp+ "disabledColor");

    LookAndFeel.installBorder(b, pp + "border");

    LookAndFeel.installColorsAndFont(b,
      pp + "background",
      pp + "foreground",
      pp + "font");
  }
}
